/* contacts-type-set.c generated by valac 0.56.17, the Vala compiler
 * generated from contacts-type-set.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * SPDX-License-Identifier: GPL-2.0-or-later
 */

#include "contactscore.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define CONTACTS_TYPE_VCARD_TYPE_MAPPING (contacts_vcard_type_mapping_get_type ())
typedef struct _ContactsVcardTypeMapping ContactsVcardTypeMapping;
enum  {
	CONTACTS_TYPESET_0_PROPERTY,
	CONTACTS_TYPESET_CATEGORY_PROPERTY,
	CONTACTS_TYPESET_NUM_PROPERTIES
};
static GParamSpec* contacts_typeset_properties[CONTACTS_TYPESET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))

struct _ContactsVcardTypeMapping {
	const gchar* name;
	const gchar* types[3];
};

struct _ContactsTypeSetPrivate {
	gchar* _category;
	ContactsTypeDescriptor* other_dummy;
	GPtrArray* vcard_type_mappings;
	GPtrArray* descriptors;
};

static gint ContactsTypeSet_private_offset;
static gpointer contacts_typeset_parent_class = NULL;
static ContactsTypeSet* contacts_typeset__general;
static ContactsTypeSet* contacts_typeset__general = NULL;
static ContactsTypeSet* contacts_typeset__email;
static ContactsTypeSet* contacts_typeset__email = NULL;
static ContactsTypeSet* contacts_typeset__phone;
static ContactsTypeSet* contacts_typeset__phone = NULL;
static GListModelInterface * contacts_typeset_g_list_model_parent_iface = NULL;

VALA_EXTERN GType contacts_vcard_type_mapping_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ContactsVcardTypeMapping* contacts_vcard_type_mapping_dup (const ContactsVcardTypeMapping* self);
VALA_EXTERN void contacts_vcard_type_mapping_free (ContactsVcardTypeMapping* self);
static void _contacts_vcard_type_mapping_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static ContactsTypeSet* contacts_typeset_new (const gchar* category);
static ContactsTypeSet* contacts_typeset_construct (GType object_type,
                                             const gchar* category);
static void contacts_typeset_add_descriptor (ContactsTypeSet* self,
                                      ContactsTypeDescriptor* descriptor);
static void contacts_typeset_add_vcard_mapping (ContactsTypeSet* self,
                                         ContactsVcardTypeMapping* vcard_mapping);
static ContactsTypeDescriptor* contacts_typeset_create_descriptor_for_custom_label (ContactsTypeSet* self,
                                                                             const gchar* label);
VALA_EXTERN gboolean contacts_vcard_type_mapping_contains (ContactsVcardTypeMapping *self,
                                               const gchar* type);
VALA_EXTERN gboolean contacts_vcard_type_mapping_matches (ContactsVcardTypeMapping *self,
                                              GeeCollection* types);
static GType contacts_typeset_real_get_item_type (GListModel* base);
static guint contacts_typeset_real_get_n_items (GListModel* base);
static GObject* contacts_typeset_real_get_item (GListModel* base,
                                         guint i);
static void contacts_typeset_finalize (GObject * obj);
static GType contacts_typeset_get_type_once (void);
static void _vala_contacts_typeset_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_contacts_typeset_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const ContactsVcardTypeMapping CONTACTS_TYPESET_general_data[2] = {{N_ ("Home"), {"HOME"}}, {N_ ("Work"), {"WORK"}}};
static const ContactsVcardTypeMapping CONTACTS_TYPESET_email_data[3] = {{N_ ("Personal"), {"PERSONAL"}}, {N_ ("Home"), {"HOME"}}, {N_ ("Work"), {"WORK"}}};
static const ContactsVcardTypeMapping CONTACTS_TYPESET_phone_data[18] = {{N_ ("Assistant"), {"X-EVOLUTION-ASSISTANT"}}, {N_ ("Work"), {"WORK", "VOICE"}}, {N_ ("Work Fax"), {"WORK", "FAX"}}, {N_ ("Work"), {"WORK"}}, {N_ ("Callback"), {"X-EVOLUTION-CALLBACK"}}, {N_ ("Car"), {"CAR"}}, {N_ ("Company"), {"X-EVOLUTION-COMPANY"}}, {N_ ("Home"), {"HOME", "VOICE"}}, {N_ ("Home Fax"), {"HOME", "FAX"}}, {N_ ("Home"), {"HOME"}}, {N_ ("ISDN"), {"ISDN"}}, {N_ ("Mobile"), {"CELL"}}, {N_ ("Other"), {"VOICE"}}, {N_ ("Fax"), {"FAX"}}, {N_ ("Pager"), {"PAGER"}}, {N_ ("Radio"), {"X-EVOLUTION-RADIO"}}, {N_ ("Telex"), {"X-EVOLUTION-TELEX"}}, {N_ ("TTY"), {"X-EVOLUTION-TTYTDD"}}};

static inline gpointer
contacts_typeset_get_instance_private (ContactsTypeSet* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsTypeSet_private_offset);
}

static void
_contacts_vcard_type_mapping_free0_ (gpointer var)
{
#line 23 "../src/core/contacts-type-set.vala"
	(var == NULL) ? NULL : (var = (contacts_vcard_type_mapping_free (var), NULL));
#line 117 "contacts-type-set.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 26 "../src/core/contacts-type-set.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 125 "contacts-type-set.c"
}

/**
   * Creates a TypeSet for the given category, e.g. "phones" (used for debugging)
   */
static ContactsTypeSet*
contacts_typeset_construct (GType object_type,
                            const gchar* category)
{
	ContactsTypeSet * self = NULL;
#line 32 "../src/core/contacts-type-set.vala"
	self = (ContactsTypeSet*) g_object_new (object_type, "category", category, NULL);
#line 31 "../src/core/contacts-type-set.vala"
	return self;
#line 140 "contacts-type-set.c"
}

static ContactsTypeSet*
contacts_typeset_new (const gchar* category)
{
#line 31 "../src/core/contacts-type-set.vala"
	return contacts_typeset_construct (CONTACTS_TYPE_TYPESET, category);
#line 148 "contacts-type-set.c"
}

/**
   * Adds the TypeDescriptor to the {@link TypeSet}'s store.
   * @param descriptor The TypeDescription to be added
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/core/contacts-type-set.vala"
	return self ? g_object_ref (self) : NULL;
#line 160 "contacts-type-set.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5950 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5951 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5951 "glib-2.0.vapi"
	return result;
#line 173 "contacts-type-set.c"
}

static void
contacts_typeset_add_descriptor (ContactsTypeSet* self,
                                 ContactsTypeDescriptor* descriptor)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GPtrArray* _tmp3_;
	ContactsTypeDescriptor* _tmp4_;
	GPtrArray* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 39 "../src/core/contacts-type-set.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/core/contacts-type-set.vala"
	g_return_if_fail (descriptor != NULL);
#line 40 "../src/core/contacts-type-set.vala"
	_tmp0_ = self->priv->_category;
#line 40 "../src/core/contacts-type-set.vala"
	_tmp1_ = contacts_typedescriptor_to_string (descriptor);
#line 40 "../src/core/contacts-type-set.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/core/contacts-type-set.vala"
	g_debug ("contacts-type-set.vala:40: %s: Adding type %s to store", _tmp0_, _tmp2_);
#line 40 "../src/core/contacts-type-set.vala"
	_g_free0 (_tmp2_);
#line 41 "../src/core/contacts-type-set.vala"
	_tmp3_ = self->priv->descriptors;
#line 41 "../src/core/contacts-type-set.vala"
	_tmp4_ = _g_object_ref0 (descriptor);
#line 41 "../src/core/contacts-type-set.vala"
	g_ptr_array_add (_tmp3_, _tmp4_);
#line 42 "../src/core/contacts-type-set.vala"
	_tmp5_ = self->priv->descriptors;
#line 42 "../src/core/contacts-type-set.vala"
	_tmp6_ = vala_g_ptr_array_get_length (_tmp5_);
#line 42 "../src/core/contacts-type-set.vala"
	_tmp7_ = _tmp6_;
#line 42 "../src/core/contacts-type-set.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) (_tmp7_ - 1), (guint) 0, (guint) 1);
#line 216 "contacts-type-set.c"
}

/**
   * Returns the TypeDescriptor for the given display name in the
   * {@link TypeSet}'s store, if any.
   *
   * @param display_name The translated display name
   * @return The appropriate TypeDescriptor or null if no match was found.
   */
ContactsTypeDescriptor*
contacts_typeset_lookup_by_display_name (ContactsTypeSet* self,
                                         const gchar* display_name,
                                         guint* position)
{
	guint _vala_position = 0U;
	ContactsTypeDescriptor* result;
#line 52 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (display_name != NULL, NULL);
#line 237 "contacts-type-set.c"
	{
		gint i = 0;
#line 54 "../src/core/contacts-type-set.vala"
		i = 0;
#line 242 "contacts-type-set.c"
		{
			gboolean _tmp0_ = FALSE;
#line 54 "../src/core/contacts-type-set.vala"
			_tmp0_ = TRUE;
#line 54 "../src/core/contacts-type-set.vala"
			while (TRUE) {
#line 249 "contacts-type-set.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				ContactsTypeDescriptor* type_descr = NULL;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				ContactsTypeDescriptor* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				ContactsTypeDescriptor* _tmp10_;
				const gchar* _tmp11_;
				ContactsTypeDescriptor* _tmp12_;
#line 54 "../src/core/contacts-type-set.vala"
				if (!_tmp0_) {
#line 264 "contacts-type-set.c"
					gint _tmp1_;
#line 54 "../src/core/contacts-type-set.vala"
					_tmp1_ = i;
#line 54 "../src/core/contacts-type-set.vala"
					i = _tmp1_ + 1;
#line 270 "contacts-type-set.c"
				}
#line 54 "../src/core/contacts-type-set.vala"
				_tmp0_ = FALSE;
#line 54 "../src/core/contacts-type-set.vala"
				_tmp2_ = self->priv->descriptors;
#line 54 "../src/core/contacts-type-set.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 54 "../src/core/contacts-type-set.vala"
				_tmp4_ = _tmp3_;
#line 54 "../src/core/contacts-type-set.vala"
				if (!(i < _tmp4_)) {
#line 54 "../src/core/contacts-type-set.vala"
					break;
#line 284 "contacts-type-set.c"
				}
#line 55 "../src/core/contacts-type-set.vala"
				_tmp5_ = self->priv->descriptors;
#line 55 "../src/core/contacts-type-set.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, (guint) i);
#line 55 "../src/core/contacts-type-set.vala"
				type_descr = (ContactsTypeDescriptor*) _tmp6_;
#line 57 "../src/core/contacts-type-set.vala"
				_tmp7_ = type_descr;
#line 57 "../src/core/contacts-type-set.vala"
				_tmp8_ = contacts_typedescriptor_get_display_name (_tmp7_);
#line 57 "../src/core/contacts-type-set.vala"
				_tmp9_ = _tmp8_;
#line 57 "../src/core/contacts-type-set.vala"
				if (g_ascii_strcasecmp (display_name, _tmp9_) != 0) {
#line 58 "../src/core/contacts-type-set.vala"
					continue;
#line 302 "contacts-type-set.c"
				}
#line 59 "../src/core/contacts-type-set.vala"
				_tmp10_ = type_descr;
#line 59 "../src/core/contacts-type-set.vala"
				_tmp11_ = _tmp10_->name;
#line 59 "../src/core/contacts-type-set.vala"
				if (g_ascii_strcasecmp (display_name, _tmp11_) != 0) {
#line 60 "../src/core/contacts-type-set.vala"
					continue;
#line 312 "contacts-type-set.c"
				}
#line 62 "../src/core/contacts-type-set.vala"
				_vala_position = (guint) i;
#line 63 "../src/core/contacts-type-set.vala"
				_tmp12_ = type_descr;
#line 63 "../src/core/contacts-type-set.vala"
				result = _tmp12_;
#line 63 "../src/core/contacts-type-set.vala"
				if (position) {
#line 63 "../src/core/contacts-type-set.vala"
					*position = _vala_position;
#line 324 "contacts-type-set.c"
				}
#line 63 "../src/core/contacts-type-set.vala"
				return result;
#line 328 "contacts-type-set.c"
			}
		}
	}
#line 67 "../src/core/contacts-type-set.vala"
	_vala_position = (guint) 0;
#line 68 "../src/core/contacts-type-set.vala"
	result = NULL;
#line 68 "../src/core/contacts-type-set.vala"
	if (position) {
#line 68 "../src/core/contacts-type-set.vala"
		*position = _vala_position;
#line 340 "contacts-type-set.c"
	}
#line 68 "../src/core/contacts-type-set.vala"
	return result;
#line 344 "contacts-type-set.c"
}

static gpointer
_contacts_vcard_type_mapping_dup0 (gpointer self)
{
#line 80 "../src/core/contacts-type-set.vala"
	return self ? contacts_vcard_type_mapping_dup (self) : NULL;
#line 352 "contacts-type-set.c"
}

static void
contacts_typeset_add_vcard_mapping (ContactsTypeSet* self,
                                    ContactsVcardTypeMapping* vcard_mapping)
{
	guint position = 0U;
	ContactsTypeDescriptor* descriptor = NULL;
	ContactsVcardTypeMapping _tmp0_;
	const gchar* _tmp1_;
	guint _tmp2_ = 0U;
	ContactsTypeDescriptor* _tmp3_;
	ContactsTypeDescriptor* _tmp4_;
	ContactsTypeDescriptor* _tmp5_;
	GPtrArray* _tmp15_;
	ContactsVcardTypeMapping _tmp16_;
	ContactsVcardTypeMapping* _tmp17_;
#line 71 "../src/core/contacts-type-set.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/core/contacts-type-set.vala"
	g_return_if_fail (vcard_mapping != NULL);
#line 73 "../src/core/contacts-type-set.vala"
	_tmp0_ = *vcard_mapping;
#line 73 "../src/core/contacts-type-set.vala"
	_tmp1_ = _tmp0_.name;
#line 73 "../src/core/contacts-type-set.vala"
	_tmp3_ = contacts_typeset_lookup_by_display_name (self, _tmp1_, &_tmp2_);
#line 73 "../src/core/contacts-type-set.vala"
	position = _tmp2_;
#line 73 "../src/core/contacts-type-set.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 73 "../src/core/contacts-type-set.vala"
	descriptor = _tmp4_;
#line 74 "../src/core/contacts-type-set.vala"
	_tmp5_ = descriptor;
#line 74 "../src/core/contacts-type-set.vala"
	if (_tmp5_ == NULL) {
#line 390 "contacts-type-set.c"
		ContactsVcardTypeMapping _tmp6_;
		const gchar* _tmp7_;
		ContactsVcardTypeMapping _tmp8_;
		ContactsTypeDescriptor* _tmp9_;
		const gchar* _tmp10_;
		ContactsTypeDescriptor* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		ContactsTypeDescriptor* _tmp14_;
#line 75 "../src/core/contacts-type-set.vala"
		_tmp6_ = *vcard_mapping;
#line 75 "../src/core/contacts-type-set.vala"
		_tmp7_ = _tmp6_.name;
#line 75 "../src/core/contacts-type-set.vala"
		_tmp8_ = *vcard_mapping;
#line 75 "../src/core/contacts-type-set.vala"
		_tmp9_ = contacts_typedescriptor_new_vcard (_tmp7_, _tmp8_.types, 3);
#line 75 "../src/core/contacts-type-set.vala"
		_g_object_unref0 (descriptor);
#line 75 "../src/core/contacts-type-set.vala"
		descriptor = _tmp9_;
#line 76 "../src/core/contacts-type-set.vala"
		_tmp10_ = self->priv->_category;
#line 76 "../src/core/contacts-type-set.vala"
		_tmp11_ = descriptor;
#line 76 "../src/core/contacts-type-set.vala"
		_tmp12_ = contacts_typedescriptor_to_string (_tmp11_);
#line 76 "../src/core/contacts-type-set.vala"
		_tmp13_ = _tmp12_;
#line 76 "../src/core/contacts-type-set.vala"
		g_debug ("contacts-type-set.vala:76: %s: Adding VCard type %s to store", _tmp10_, _tmp13_);
#line 76 "../src/core/contacts-type-set.vala"
		_g_free0 (_tmp13_);
#line 77 "../src/core/contacts-type-set.vala"
		_tmp14_ = descriptor;
#line 77 "../src/core/contacts-type-set.vala"
		contacts_typeset_add_descriptor (self, _tmp14_);
#line 428 "contacts-type-set.c"
	}
#line 80 "../src/core/contacts-type-set.vala"
	_tmp15_ = self->priv->vcard_type_mappings;
#line 80 "../src/core/contacts-type-set.vala"
	_tmp16_ = *vcard_mapping;
#line 80 "../src/core/contacts-type-set.vala"
	_tmp17_ = _contacts_vcard_type_mapping_dup0 (&_tmp16_);
#line 80 "../src/core/contacts-type-set.vala"
	g_ptr_array_add (_tmp15_, _tmp17_);
#line 71 "../src/core/contacts-type-set.vala"
	_g_object_unref0 (descriptor);
#line 440 "contacts-type-set.c"
}

/**
   * Tries to find the TypeDescriptor matching the given custom label, or null if none.
   */
ContactsTypeDescriptor*
contacts_typeset_lookup_by_custom_label (ContactsTypeSet* self,
                                         const gchar* label,
                                         guint* position)
{
	guint _vala_position = 0U;
	ContactsTypeDescriptor* descriptor = NULL;
	guint _tmp0_ = 0U;
	ContactsTypeDescriptor* _tmp1_;
	ContactsTypeDescriptor* _tmp2_;
	guint _tmp5_ = 0U;
	ContactsTypeDescriptor* _tmp6_;
	ContactsTypeDescriptor* _tmp7_;
	ContactsTypeDescriptor* _tmp8_;
	ContactsTypeDescriptor* result;
#line 86 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 89 "../src/core/contacts-type-set.vala"
	_tmp1_ = contacts_typeset_lookup_by_display_name (self, label, &_tmp0_);
#line 89 "../src/core/contacts-type-set.vala"
	_vala_position = _tmp0_;
#line 89 "../src/core/contacts-type-set.vala"
	descriptor = _tmp1_;
#line 90 "../src/core/contacts-type-set.vala"
	_tmp2_ = descriptor;
#line 90 "../src/core/contacts-type-set.vala"
	if (_tmp2_ != NULL) {
#line 475 "contacts-type-set.c"
		ContactsTypeDescriptor* _tmp3_;
		ContactsTypeDescriptor* _tmp4_;
#line 91 "../src/core/contacts-type-set.vala"
		_tmp3_ = descriptor;
#line 91 "../src/core/contacts-type-set.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 91 "../src/core/contacts-type-set.vala"
		result = _tmp4_;
#line 91 "../src/core/contacts-type-set.vala"
		if (position) {
#line 91 "../src/core/contacts-type-set.vala"
			*position = _vala_position;
#line 488 "contacts-type-set.c"
		}
#line 91 "../src/core/contacts-type-set.vala"
		return result;
#line 492 "contacts-type-set.c"
	}
#line 94 "../src/core/contacts-type-set.vala"
	_tmp6_ = contacts_typeset_lookup_by_vcard_type (self, label, &_tmp5_);
#line 94 "../src/core/contacts-type-set.vala"
	_vala_position = _tmp5_;
#line 94 "../src/core/contacts-type-set.vala"
	descriptor = _tmp6_;
#line 95 "../src/core/contacts-type-set.vala"
	_tmp7_ = descriptor;
#line 95 "../src/core/contacts-type-set.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 95 "../src/core/contacts-type-set.vala"
	result = _tmp8_;
#line 95 "../src/core/contacts-type-set.vala"
	if (position) {
#line 95 "../src/core/contacts-type-set.vala"
		*position = _vala_position;
#line 510 "contacts-type-set.c"
	}
#line 95 "../src/core/contacts-type-set.vala"
	return result;
#line 514 "contacts-type-set.c"
}

static ContactsTypeDescriptor*
contacts_typeset_create_descriptor_for_custom_label (ContactsTypeSet* self,
                                                     const gchar* label)
{
	ContactsTypeDescriptor* new_descriptor = NULL;
	ContactsTypeDescriptor* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ContactsTypeDescriptor* result;
#line 98 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 99 "../src/core/contacts-type-set.vala"
	_tmp0_ = contacts_typedescriptor_new_custom (label);
#line 99 "../src/core/contacts-type-set.vala"
	new_descriptor = _tmp0_;
#line 100 "../src/core/contacts-type-set.vala"
	_tmp1_ = self->priv->_category;
#line 100 "../src/core/contacts-type-set.vala"
	_tmp2_ = contacts_typedescriptor_to_string (new_descriptor);
#line 100 "../src/core/contacts-type-set.vala"
	_tmp3_ = _tmp2_;
#line 100 "../src/core/contacts-type-set.vala"
	g_debug ("contacts-type-set.vala:100: %s: Adding custom type %s to store", _tmp1_, _tmp3_);
#line 100 "../src/core/contacts-type-set.vala"
	_g_free0 (_tmp3_);
#line 102 "../src/core/contacts-type-set.vala"
	contacts_typeset_add_descriptor (self, new_descriptor);
#line 103 "../src/core/contacts-type-set.vala"
	result = new_descriptor;
#line 103 "../src/core/contacts-type-set.vala"
	return result;
#line 551 "contacts-type-set.c"
}

/**
   * Returns the TypeDescriptor which corresponds the best to the given vcard type.
   * @param str A VCard-like type, such as "HOME" or "CELL".
   */
ContactsTypeDescriptor*
contacts_typeset_lookup_by_vcard_type (ContactsTypeSet* self,
                                       const gchar* str,
                                       guint* position)
{
	guint _vala_position = 0U;
	GPtrArray* _tmp0_;
	ContactsTypeDescriptor* result;
#line 110 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 112 "../src/core/contacts-type-set.vala"
	_tmp0_ = self->priv->vcard_type_mappings;
#line 572 "contacts-type-set.c"
	{
		GPtrArray* mapping_collection = NULL;
		guint mapping_index = 0U;
#line 112 "../src/core/contacts-type-set.vala"
		mapping_collection = _tmp0_;
#line 112 "../src/core/contacts-type-set.vala"
		for (mapping_index = 0; mapping_index < mapping_collection->len; mapping_index = mapping_index + 1) {
#line 580 "contacts-type-set.c"
			ContactsVcardTypeMapping* mapping = NULL;
#line 112 "../src/core/contacts-type-set.vala"
			mapping = (ContactsVcardTypeMapping*) g_ptr_array_index (mapping_collection, mapping_index);
#line 584 "contacts-type-set.c"
			{
				ContactsVcardTypeMapping* _tmp1_;
#line 113 "../src/core/contacts-type-set.vala"
				_tmp1_ = mapping;
#line 113 "../src/core/contacts-type-set.vala"
				if (contacts_vcard_type_mapping_contains (_tmp1_, str)) {
#line 591 "contacts-type-set.c"
					ContactsVcardTypeMapping* _tmp2_;
					const gchar* _tmp3_;
					guint _tmp4_ = 0U;
					ContactsTypeDescriptor* _tmp5_;
#line 114 "../src/core/contacts-type-set.vala"
					_tmp2_ = mapping;
#line 114 "../src/core/contacts-type-set.vala"
					_tmp3_ = (*_tmp2_).name;
#line 114 "../src/core/contacts-type-set.vala"
					_tmp5_ = contacts_typeset_lookup_by_display_name (self, _tmp3_, &_tmp4_);
#line 114 "../src/core/contacts-type-set.vala"
					_vala_position = _tmp4_;
#line 114 "../src/core/contacts-type-set.vala"
					result = _tmp5_;
#line 114 "../src/core/contacts-type-set.vala"
					if (position) {
#line 114 "../src/core/contacts-type-set.vala"
						*position = _vala_position;
#line 610 "contacts-type-set.c"
					}
#line 114 "../src/core/contacts-type-set.vala"
					return result;
#line 614 "contacts-type-set.c"
				}
			}
		}
	}
#line 117 "../src/core/contacts-type-set.vala"
	_vala_position = (guint) 0;
#line 118 "../src/core/contacts-type-set.vala"
	result = NULL;
#line 118 "../src/core/contacts-type-set.vala"
	if (position) {
#line 118 "../src/core/contacts-type-set.vala"
		*position = _vala_position;
#line 627 "contacts-type-set.c"
	}
#line 118 "../src/core/contacts-type-set.vala"
	return result;
#line 631 "contacts-type-set.c"
}

/**
   * Looks up the TypeDescriptor for the given parameters. If the descriptor
   * is not found, it will be created and returned, so this never returns null.
   */
ContactsTypeDescriptor*
contacts_typeset_lookup_by_parameters (ContactsTypeSet* self,
                                       GeeMultiMap* parameters,
                                       guint* position)
{
	guint _vala_position = 0U;
	GeeCollection* google_label = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeCollection* types = NULL;
	GeeCollection* _tmp17_;
	gboolean _tmp18_ = FALSE;
	GeeCollection* _tmp19_;
	GPtrArray* _tmp25_;
	ContactsTypeDescriptor* _tmp33_;
	ContactsTypeDescriptor* _tmp34_;
	ContactsTypeDescriptor* result;
#line 125 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (parameters != NULL, NULL);
#line 127 "../src/core/contacts-type-set.vala"
	_tmp0_ = gee_multi_map_get (parameters, CONTACTS_TYPEDESCRIPTOR_X_GOOGLE_LABEL);
#line 127 "../src/core/contacts-type-set.vala"
	google_label = _tmp0_;
#line 128 "../src/core/contacts-type-set.vala"
	_tmp1_ = google_label;
#line 128 "../src/core/contacts-type-set.vala"
	_tmp2_ = gee_collection_get_is_empty (_tmp1_);
#line 128 "../src/core/contacts-type-set.vala"
	_tmp3_ = _tmp2_;
#line 128 "../src/core/contacts-type-set.vala"
	if (!_tmp3_) {
#line 673 "contacts-type-set.c"
		gchar* label = NULL;
		GeeCollection* _tmp4_;
		gint _tmp5_ = 0;
		gpointer* _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		ContactsTypeDescriptor* descriptor = NULL;
		const gchar* _tmp11_;
		guint _tmp12_ = 0U;
		ContactsTypeDescriptor* _tmp13_;
		ContactsTypeDescriptor* _tmp14_;
#line 129 "../src/core/contacts-type-set.vala"
		_tmp4_ = google_label;
#line 129 "../src/core/contacts-type-set.vala"
		_tmp6_ = gee_collection_to_array (_tmp4_, &_tmp5_);
#line 129 "../src/core/contacts-type-set.vala"
		_tmp7_ = _tmp6_;
#line 129 "../src/core/contacts-type-set.vala"
		_tmp7__length1 = _tmp5_;
#line 129 "../src/core/contacts-type-set.vala"
		_tmp8_ = _tmp7_[0];
#line 129 "../src/core/contacts-type-set.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 129 "../src/core/contacts-type-set.vala"
		_tmp10_ = _tmp9_;
#line 129 "../src/core/contacts-type-set.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 129 "../src/core/contacts-type-set.vala"
		label = _tmp10_;
#line 130 "../src/core/contacts-type-set.vala"
		_tmp11_ = label;
#line 130 "../src/core/contacts-type-set.vala"
		_tmp13_ = contacts_typeset_lookup_by_custom_label (self, _tmp11_, &_tmp12_);
#line 130 "../src/core/contacts-type-set.vala"
		_vala_position = _tmp12_;
#line 130 "../src/core/contacts-type-set.vala"
		descriptor = _tmp13_;
#line 132 "../src/core/contacts-type-set.vala"
		_tmp14_ = descriptor;
#line 132 "../src/core/contacts-type-set.vala"
		if (_tmp14_ == NULL) {
#line 718 "contacts-type-set.c"
			const gchar* _tmp15_;
			ContactsTypeDescriptor* _tmp16_;
#line 133 "../src/core/contacts-type-set.vala"
			_tmp15_ = label;
#line 133 "../src/core/contacts-type-set.vala"
			_tmp16_ = contacts_typeset_create_descriptor_for_custom_label (self, _tmp15_);
#line 133 "../src/core/contacts-type-set.vala"
			_g_object_unref0 (descriptor);
#line 133 "../src/core/contacts-type-set.vala"
			descriptor = _tmp16_;
#line 729 "contacts-type-set.c"
		}
#line 134 "../src/core/contacts-type-set.vala"
		result = descriptor;
#line 134 "../src/core/contacts-type-set.vala"
		_g_free0 (label);
#line 134 "../src/core/contacts-type-set.vala"
		_g_object_unref0 (google_label);
#line 134 "../src/core/contacts-type-set.vala"
		if (position) {
#line 134 "../src/core/contacts-type-set.vala"
			*position = _vala_position;
#line 741 "contacts-type-set.c"
		}
#line 134 "../src/core/contacts-type-set.vala"
		return result;
#line 745 "contacts-type-set.c"
	}
#line 137 "../src/core/contacts-type-set.vala"
	_tmp17_ = gee_multi_map_get (parameters, "type");
#line 137 "../src/core/contacts-type-set.vala"
	types = _tmp17_;
#line 138 "../src/core/contacts-type-set.vala"
	_tmp19_ = types;
#line 138 "../src/core/contacts-type-set.vala"
	if (_tmp19_ == NULL) {
#line 138 "../src/core/contacts-type-set.vala"
		_tmp18_ = TRUE;
#line 757 "contacts-type-set.c"
	} else {
		GeeCollection* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 138 "../src/core/contacts-type-set.vala"
		_tmp20_ = types;
#line 138 "../src/core/contacts-type-set.vala"
		_tmp21_ = gee_collection_get_is_empty (_tmp20_);
#line 138 "../src/core/contacts-type-set.vala"
		_tmp22_ = _tmp21_;
#line 138 "../src/core/contacts-type-set.vala"
		_tmp18_ = _tmp22_;
#line 770 "contacts-type-set.c"
	}
#line 138 "../src/core/contacts-type-set.vala"
	if (_tmp18_) {
#line 774 "contacts-type-set.c"
		ContactsTypeDescriptor* _tmp23_;
		ContactsTypeDescriptor* _tmp24_;
#line 139 "../src/core/contacts-type-set.vala"
		g_debug ("contacts-type-set.vala:139: No types given in the AbstractFieldDetails");
#line 140 "../src/core/contacts-type-set.vala"
		_tmp23_ = self->priv->other_dummy;
#line 140 "../src/core/contacts-type-set.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 140 "../src/core/contacts-type-set.vala"
		result = _tmp24_;
#line 140 "../src/core/contacts-type-set.vala"
		_g_object_unref0 (types);
#line 140 "../src/core/contacts-type-set.vala"
		_g_object_unref0 (google_label);
#line 140 "../src/core/contacts-type-set.vala"
		if (position) {
#line 140 "../src/core/contacts-type-set.vala"
			*position = _vala_position;
#line 793 "contacts-type-set.c"
		}
#line 140 "../src/core/contacts-type-set.vala"
		return result;
#line 797 "contacts-type-set.c"
	}
#line 143 "../src/core/contacts-type-set.vala"
	_tmp25_ = self->priv->vcard_type_mappings;
#line 801 "contacts-type-set.c"
	{
		GPtrArray* mapping_collection = NULL;
		guint mapping_index = 0U;
#line 143 "../src/core/contacts-type-set.vala"
		mapping_collection = _tmp25_;
#line 143 "../src/core/contacts-type-set.vala"
		for (mapping_index = 0; mapping_index < mapping_collection->len; mapping_index = mapping_index + 1) {
#line 809 "contacts-type-set.c"
			ContactsVcardTypeMapping* mapping = NULL;
#line 143 "../src/core/contacts-type-set.vala"
			mapping = (ContactsVcardTypeMapping*) g_ptr_array_index (mapping_collection, mapping_index);
#line 813 "contacts-type-set.c"
			{
				ContactsVcardTypeMapping* _tmp26_;
				GeeCollection* _tmp27_;
#line 144 "../src/core/contacts-type-set.vala"
				_tmp26_ = mapping;
#line 144 "../src/core/contacts-type-set.vala"
				_tmp27_ = types;
#line 144 "../src/core/contacts-type-set.vala"
				if (contacts_vcard_type_mapping_matches (_tmp26_, _tmp27_)) {
#line 823 "contacts-type-set.c"
					ContactsVcardTypeMapping* _tmp28_;
					const gchar* _tmp29_;
					guint _tmp30_ = 0U;
					ContactsTypeDescriptor* _tmp31_;
					ContactsTypeDescriptor* _tmp32_;
#line 145 "../src/core/contacts-type-set.vala"
					_tmp28_ = mapping;
#line 145 "../src/core/contacts-type-set.vala"
					_tmp29_ = (*_tmp28_).name;
#line 145 "../src/core/contacts-type-set.vala"
					_tmp31_ = contacts_typeset_lookup_by_display_name (self, _tmp29_, &_tmp30_);
#line 145 "../src/core/contacts-type-set.vala"
					_vala_position = _tmp30_;
#line 145 "../src/core/contacts-type-set.vala"
					_tmp32_ = _g_object_ref0 (_tmp31_);
#line 145 "../src/core/contacts-type-set.vala"
					result = _tmp32_;
#line 145 "../src/core/contacts-type-set.vala"
					_g_object_unref0 (types);
#line 145 "../src/core/contacts-type-set.vala"
					_g_object_unref0 (google_label);
#line 145 "../src/core/contacts-type-set.vala"
					if (position) {
#line 145 "../src/core/contacts-type-set.vala"
						*position = _vala_position;
#line 849 "contacts-type-set.c"
					}
#line 145 "../src/core/contacts-type-set.vala"
					return result;
#line 853 "contacts-type-set.c"
				}
			}
		}
	}
#line 148 "../src/core/contacts-type-set.vala"
	_tmp33_ = self->priv->other_dummy;
#line 148 "../src/core/contacts-type-set.vala"
	_tmp34_ = _g_object_ref0 (_tmp33_);
#line 148 "../src/core/contacts-type-set.vala"
	result = _tmp34_;
#line 148 "../src/core/contacts-type-set.vala"
	_g_object_unref0 (types);
#line 148 "../src/core/contacts-type-set.vala"
	_g_object_unref0 (google_label);
#line 148 "../src/core/contacts-type-set.vala"
	if (position) {
#line 148 "../src/core/contacts-type-set.vala"
		*position = _vala_position;
#line 872 "contacts-type-set.c"
	}
#line 148 "../src/core/contacts-type-set.vala"
	return result;
#line 876 "contacts-type-set.c"
}

static GType
contacts_typeset_real_get_item_type (GListModel* base)
{
	ContactsTypeSet * self;
	GType result;
#line 151 "../src/core/contacts-type-set.vala"
	self = (ContactsTypeSet*) base;
#line 152 "../src/core/contacts-type-set.vala"
	result = CONTACTS_TYPE_TYPEDESCRIPTOR;
#line 152 "../src/core/contacts-type-set.vala"
	return result;
#line 890 "contacts-type-set.c"
}

static guint
contacts_typeset_real_get_n_items (GListModel* base)
{
	ContactsTypeSet * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint result;
#line 155 "../src/core/contacts-type-set.vala"
	self = (ContactsTypeSet*) base;
#line 156 "../src/core/contacts-type-set.vala"
	_tmp0_ = self->priv->descriptors;
#line 156 "../src/core/contacts-type-set.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 156 "../src/core/contacts-type-set.vala"
	_tmp2_ = _tmp1_;
#line 156 "../src/core/contacts-type-set.vala"
	result = (guint) _tmp2_;
#line 156 "../src/core/contacts-type-set.vala"
	return result;
#line 913 "contacts-type-set.c"
}

static GObject*
contacts_typeset_real_get_item (GListModel* base,
                                guint i)
{
	ContactsTypeSet * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp3_;
	gconstpointer _tmp4_;
	GObject* _tmp5_;
	GObject* result;
#line 159 "../src/core/contacts-type-set.vala"
	self = (ContactsTypeSet*) base;
#line 160 "../src/core/contacts-type-set.vala"
	_tmp0_ = self->priv->descriptors;
#line 160 "../src/core/contacts-type-set.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 160 "../src/core/contacts-type-set.vala"
	_tmp2_ = _tmp1_;
#line 160 "../src/core/contacts-type-set.vala"
	if (i > ((guint) _tmp2_)) {
#line 161 "../src/core/contacts-type-set.vala"
		result = NULL;
#line 161 "../src/core/contacts-type-set.vala"
		return result;
#line 942 "contacts-type-set.c"
	}
#line 163 "../src/core/contacts-type-set.vala"
	_tmp3_ = self->priv->descriptors;
#line 163 "../src/core/contacts-type-set.vala"
	_tmp4_ = g_ptr_array_index (_tmp3_, i);
#line 163 "../src/core/contacts-type-set.vala"
	_tmp5_ = _g_object_ref0 ((GObject*) ((ContactsTypeDescriptor*) _tmp4_));
#line 163 "../src/core/contacts-type-set.vala"
	result = _tmp5_;
#line 163 "../src/core/contacts-type-set.vala"
	return result;
#line 954 "contacts-type-set.c"
}

const gchar*
contacts_typeset_get_category (ContactsTypeSet* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 17 "../src/core/contacts-type-set.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 17 "../src/core/contacts-type-set.vala"
	_tmp0_ = self->priv->_category;
#line 17 "../src/core/contacts-type-set.vala"
	result = _tmp0_;
#line 17 "../src/core/contacts-type-set.vala"
	return result;
#line 970 "contacts-type-set.c"
}

void
contacts_typeset_set_category (ContactsTypeSet* self,
                               const gchar* value)
{
	gchar* old_value;
#line 17 "../src/core/contacts-type-set.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/core/contacts-type-set.vala"
	old_value = contacts_typeset_get_category (self);
#line 17 "../src/core/contacts-type-set.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 984 "contacts-type-set.c"
		gchar* _tmp0_;
#line 17 "../src/core/contacts-type-set.vala"
		_tmp0_ = g_strdup (value);
#line 17 "../src/core/contacts-type-set.vala"
		_g_free0 (self->priv->_category);
#line 17 "../src/core/contacts-type-set.vala"
		self->priv->_category = _tmp0_;
#line 17 "../src/core/contacts-type-set.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_typeset_properties[CONTACTS_TYPESET_CATEGORY_PROPERTY]);
#line 994 "contacts-type-set.c"
	}
}

ContactsTypeSet*
contacts_typeset_get_general (void)
{
	ContactsTypeSet* result;
	ContactsTypeSet* _tmp0_;
	ContactsTypeSet* _tmp10_;
#line 174 "../src/core/contacts-type-set.vala"
	_tmp0_ = contacts_typeset__general;
#line 174 "../src/core/contacts-type-set.vala"
	if (_tmp0_ == NULL) {
#line 1008 "contacts-type-set.c"
		ContactsTypeSet* _tmp1_;
		ContactsTypeSet* _tmp6_;
		ContactsTypeSet* _tmp7_;
		ContactsTypeSet* _tmp8_;
		ContactsTypeDescriptor* _tmp9_;
#line 175 "../src/core/contacts-type-set.vala"
		_tmp1_ = contacts_typeset_new ("General");
#line 175 "../src/core/contacts-type-set.vala"
		_g_object_unref0 (contacts_typeset__general);
#line 175 "../src/core/contacts-type-set.vala"
		contacts_typeset__general = _tmp1_;
#line 1020 "contacts-type-set.c"
		{
			gint i = 0;
#line 176 "../src/core/contacts-type-set.vala"
			i = 0;
#line 1025 "contacts-type-set.c"
			{
				gboolean _tmp2_ = FALSE;
#line 176 "../src/core/contacts-type-set.vala"
				_tmp2_ = TRUE;
#line 176 "../src/core/contacts-type-set.vala"
				while (TRUE) {
#line 1032 "contacts-type-set.c"
					ContactsTypeSet* _tmp4_;
					ContactsVcardTypeMapping _tmp5_;
#line 176 "../src/core/contacts-type-set.vala"
					if (!_tmp2_) {
#line 1037 "contacts-type-set.c"
						gint _tmp3_;
#line 176 "../src/core/contacts-type-set.vala"
						_tmp3_ = i;
#line 176 "../src/core/contacts-type-set.vala"
						i = _tmp3_ + 1;
#line 1043 "contacts-type-set.c"
					}
#line 176 "../src/core/contacts-type-set.vala"
					_tmp2_ = FALSE;
#line 176 "../src/core/contacts-type-set.vala"
					if (!(i < G_N_ELEMENTS (CONTACTS_TYPESET_general_data))) {
#line 176 "../src/core/contacts-type-set.vala"
						break;
#line 1051 "contacts-type-set.c"
					}
#line 177 "../src/core/contacts-type-set.vala"
					_tmp4_ = contacts_typeset__general;
#line 177 "../src/core/contacts-type-set.vala"
					_tmp5_ = CONTACTS_TYPESET_general_data[i];
#line 177 "../src/core/contacts-type-set.vala"
					contacts_typeset_add_vcard_mapping (_tmp4_, &_tmp5_);
#line 1059 "contacts-type-set.c"
				}
			}
		}
#line 179 "../src/core/contacts-type-set.vala"
		_tmp6_ = contacts_typeset__general;
#line 179 "../src/core/contacts-type-set.vala"
		_tmp7_ = contacts_typeset_get_general ();
#line 179 "../src/core/contacts-type-set.vala"
		_tmp8_ = _tmp7_;
#line 179 "../src/core/contacts-type-set.vala"
		_tmp9_ = _tmp8_->priv->other_dummy;
#line 179 "../src/core/contacts-type-set.vala"
		contacts_typeset_add_descriptor (_tmp6_, _tmp9_);
#line 1073 "contacts-type-set.c"
	}
#line 182 "../src/core/contacts-type-set.vala"
	_tmp10_ = contacts_typeset__general;
#line 182 "../src/core/contacts-type-set.vala"
	result = _tmp10_;
#line 182 "../src/core/contacts-type-set.vala"
	return result;
#line 1081 "contacts-type-set.c"
}

ContactsTypeSet*
contacts_typeset_get_email (void)
{
	ContactsTypeSet* result;
	ContactsTypeSet* _tmp0_;
	ContactsTypeSet* _tmp9_;
#line 195 "../src/core/contacts-type-set.vala"
	_tmp0_ = contacts_typeset__email;
#line 195 "../src/core/contacts-type-set.vala"
	if (_tmp0_ == NULL) {
#line 1094 "contacts-type-set.c"
		ContactsTypeSet* _tmp1_;
		ContactsTypeSet* _tmp6_;
		ContactsTypeSet* _tmp7_;
		ContactsTypeDescriptor* _tmp8_;
#line 196 "../src/core/contacts-type-set.vala"
		_tmp1_ = contacts_typeset_new ("Emails");
#line 196 "../src/core/contacts-type-set.vala"
		_g_object_unref0 (contacts_typeset__email);
#line 196 "../src/core/contacts-type-set.vala"
		contacts_typeset__email = _tmp1_;
#line 1105 "contacts-type-set.c"
		{
			gint i = 0;
#line 197 "../src/core/contacts-type-set.vala"
			i = 0;
#line 1110 "contacts-type-set.c"
			{
				gboolean _tmp2_ = FALSE;
#line 197 "../src/core/contacts-type-set.vala"
				_tmp2_ = TRUE;
#line 197 "../src/core/contacts-type-set.vala"
				while (TRUE) {
#line 1117 "contacts-type-set.c"
					ContactsTypeSet* _tmp4_;
					ContactsVcardTypeMapping _tmp5_;
#line 197 "../src/core/contacts-type-set.vala"
					if (!_tmp2_) {
#line 1122 "contacts-type-set.c"
						gint _tmp3_;
#line 197 "../src/core/contacts-type-set.vala"
						_tmp3_ = i;
#line 197 "../src/core/contacts-type-set.vala"
						i = _tmp3_ + 1;
#line 1128 "contacts-type-set.c"
					}
#line 197 "../src/core/contacts-type-set.vala"
					_tmp2_ = FALSE;
#line 197 "../src/core/contacts-type-set.vala"
					if (!(i < G_N_ELEMENTS (CONTACTS_TYPESET_email_data))) {
#line 197 "../src/core/contacts-type-set.vala"
						break;
#line 1136 "contacts-type-set.c"
					}
#line 198 "../src/core/contacts-type-set.vala"
					_tmp4_ = contacts_typeset__email;
#line 198 "../src/core/contacts-type-set.vala"
					_tmp5_ = CONTACTS_TYPESET_email_data[i];
#line 198 "../src/core/contacts-type-set.vala"
					contacts_typeset_add_vcard_mapping (_tmp4_, &_tmp5_);
#line 1144 "contacts-type-set.c"
				}
			}
		}
#line 199 "../src/core/contacts-type-set.vala"
		_tmp6_ = contacts_typeset__email;
#line 199 "../src/core/contacts-type-set.vala"
		_tmp7_ = contacts_typeset__email;
#line 199 "../src/core/contacts-type-set.vala"
		_tmp8_ = _tmp7_->priv->other_dummy;
#line 199 "../src/core/contacts-type-set.vala"
		contacts_typeset_add_descriptor (_tmp6_, _tmp8_);
#line 1156 "contacts-type-set.c"
	}
#line 202 "../src/core/contacts-type-set.vala"
	_tmp9_ = contacts_typeset__email;
#line 202 "../src/core/contacts-type-set.vala"
	result = _tmp9_;
#line 202 "../src/core/contacts-type-set.vala"
	return result;
#line 1164 "contacts-type-set.c"
}

ContactsTypeSet*
contacts_typeset_get_phone (void)
{
	ContactsTypeSet* result;
	ContactsTypeSet* _tmp0_;
	ContactsTypeSet* _tmp9_;
#line 232 "../src/core/contacts-type-set.vala"
	_tmp0_ = contacts_typeset__phone;
#line 232 "../src/core/contacts-type-set.vala"
	if (_tmp0_ == NULL) {
#line 1177 "contacts-type-set.c"
		ContactsTypeSet* _tmp1_;
		ContactsTypeSet* _tmp6_;
		ContactsTypeSet* _tmp7_;
		ContactsTypeDescriptor* _tmp8_;
#line 233 "../src/core/contacts-type-set.vala"
		_tmp1_ = contacts_typeset_new ("Phones");
#line 233 "../src/core/contacts-type-set.vala"
		_g_object_unref0 (contacts_typeset__phone);
#line 233 "../src/core/contacts-type-set.vala"
		contacts_typeset__phone = _tmp1_;
#line 1188 "contacts-type-set.c"
		{
			gint i = 0;
#line 234 "../src/core/contacts-type-set.vala"
			i = 0;
#line 1193 "contacts-type-set.c"
			{
				gboolean _tmp2_ = FALSE;
#line 234 "../src/core/contacts-type-set.vala"
				_tmp2_ = TRUE;
#line 234 "../src/core/contacts-type-set.vala"
				while (TRUE) {
#line 1200 "contacts-type-set.c"
					ContactsTypeSet* _tmp4_;
					ContactsVcardTypeMapping _tmp5_;
#line 234 "../src/core/contacts-type-set.vala"
					if (!_tmp2_) {
#line 1205 "contacts-type-set.c"
						gint _tmp3_;
#line 234 "../src/core/contacts-type-set.vala"
						_tmp3_ = i;
#line 234 "../src/core/contacts-type-set.vala"
						i = _tmp3_ + 1;
#line 1211 "contacts-type-set.c"
					}
#line 234 "../src/core/contacts-type-set.vala"
					_tmp2_ = FALSE;
#line 234 "../src/core/contacts-type-set.vala"
					if (!(i < G_N_ELEMENTS (CONTACTS_TYPESET_phone_data))) {
#line 234 "../src/core/contacts-type-set.vala"
						break;
#line 1219 "contacts-type-set.c"
					}
#line 235 "../src/core/contacts-type-set.vala"
					_tmp4_ = contacts_typeset__phone;
#line 235 "../src/core/contacts-type-set.vala"
					_tmp5_ = CONTACTS_TYPESET_phone_data[i];
#line 235 "../src/core/contacts-type-set.vala"
					contacts_typeset_add_vcard_mapping (_tmp4_, &_tmp5_);
#line 1227 "contacts-type-set.c"
				}
			}
		}
#line 236 "../src/core/contacts-type-set.vala"
		_tmp6_ = contacts_typeset__phone;
#line 236 "../src/core/contacts-type-set.vala"
		_tmp7_ = contacts_typeset__phone;
#line 236 "../src/core/contacts-type-set.vala"
		_tmp8_ = _tmp7_->priv->other_dummy;
#line 236 "../src/core/contacts-type-set.vala"
		contacts_typeset_add_descriptor (_tmp6_, _tmp8_);
#line 1239 "contacts-type-set.c"
	}
#line 239 "../src/core/contacts-type-set.vala"
	_tmp9_ = contacts_typeset__phone;
#line 239 "../src/core/contacts-type-set.vala"
	result = _tmp9_;
#line 239 "../src/core/contacts-type-set.vala"
	return result;
#line 1247 "contacts-type-set.c"
}

static void
contacts_typeset_class_init (ContactsTypeSetClass * klass,
                             gpointer klass_data)
{
#line 14 "../src/core/contacts-type-set.vala"
	contacts_typeset_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/core/contacts-type-set.vala"
	g_type_class_adjust_private_offset (klass, &ContactsTypeSet_private_offset);
#line 14 "../src/core/contacts-type-set.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_typeset_get_property;
#line 14 "../src/core/contacts-type-set.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_typeset_set_property;
#line 14 "../src/core/contacts-type-set.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_typeset_finalize;
#line 1264 "contacts-type-set.c"
	/** Returns the category of typeset (mostly used for debugging). */
#line 14 "../src/core/contacts-type-set.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_TYPESET_CATEGORY_PROPERTY, contacts_typeset_properties[CONTACTS_TYPESET_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1268 "contacts-type-set.c"
}

static void
contacts_typeset_g_list_model_interface_init (GListModelInterface * iface,
                                              gpointer iface_data)
{
#line 14 "../src/core/contacts-type-set.vala"
	contacts_typeset_g_list_model_parent_iface = g_type_interface_peek_parent (iface);
#line 14 "../src/core/contacts-type-set.vala"
	iface->get_item_type = (GType (*) (GListModel*)) contacts_typeset_real_get_item_type;
#line 14 "../src/core/contacts-type-set.vala"
	iface->get_n_items = (guint (*) (GListModel*)) contacts_typeset_real_get_n_items;
#line 14 "../src/core/contacts-type-set.vala"
	iface->get_item = (GObject* (*) (GListModel*, guint)) contacts_typeset_real_get_item;
#line 1283 "contacts-type-set.c"
}

static void
contacts_typeset_instance_init (ContactsTypeSet * self,
                                gpointer klass)
{
	ContactsTypeDescriptor* _tmp0_;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp2_;
#line 14 "../src/core/contacts-type-set.vala"
	self->priv = contacts_typeset_get_instance_private (self);
#line 20 "../src/core/contacts-type-set.vala"
	_tmp0_ = contacts_typedescriptor_new_other ();
#line 20 "../src/core/contacts-type-set.vala"
	self->priv->other_dummy = _tmp0_;
#line 23 "../src/core/contacts-type-set.vala"
	_tmp1_ = g_ptr_array_new_full ((guint) 0, _contacts_vcard_type_mapping_free0_);
#line 23 "../src/core/contacts-type-set.vala"
	self->priv->vcard_type_mappings = _tmp1_;
#line 26 "../src/core/contacts-type-set.vala"
	_tmp2_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 26 "../src/core/contacts-type-set.vala"
	self->priv->descriptors = _tmp2_;
#line 1307 "contacts-type-set.c"
}

static void
contacts_typeset_finalize (GObject * obj)
{
	ContactsTypeSet * self;
#line 14 "../src/core/contacts-type-set.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_TYPESET, ContactsTypeSet);
#line 17 "../src/core/contacts-type-set.vala"
	_g_free0 (self->priv->_category);
#line 20 "../src/core/contacts-type-set.vala"
	_g_object_unref0 (self->priv->other_dummy);
#line 23 "../src/core/contacts-type-set.vala"
	_g_ptr_array_unref0 (self->priv->vcard_type_mappings);
#line 26 "../src/core/contacts-type-set.vala"
	_g_ptr_array_unref0 (self->priv->descriptors);
#line 14 "../src/core/contacts-type-set.vala"
	G_OBJECT_CLASS (contacts_typeset_parent_class)->finalize (obj);
#line 1326 "contacts-type-set.c"
}

/**
 * A TypeSet contains all the possible types of a property. For example, a
 * phone number can be both for a personal phone, a work phone or even a fax
 * machine.
 */
 G_GNUC_NO_INLINE static GType
contacts_typeset_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsTypeSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_typeset_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsTypeSet), 0, (GInstanceInitFunc) contacts_typeset_instance_init, NULL };
	static const GInterfaceInfo g_list_model_info = { (GInterfaceInitFunc) contacts_typeset_g_list_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType contacts_typeset_type_id;
	contacts_typeset_type_id = g_type_register_static (G_TYPE_OBJECT, "ContactsTypeSet", &g_define_type_info, 0);
	g_type_add_interface_static (contacts_typeset_type_id, g_list_model_get_type (), &g_list_model_info);
	ContactsTypeSet_private_offset = g_type_add_instance_private (contacts_typeset_type_id, sizeof (ContactsTypeSetPrivate));
	return contacts_typeset_type_id;
}

GType
contacts_typeset_get_type (void)
{
	static volatile gsize contacts_typeset_type_id__once = 0;
	if (g_once_init_enter (&contacts_typeset_type_id__once)) {
		GType contacts_typeset_type_id;
		contacts_typeset_type_id = contacts_typeset_get_type_once ();
		g_once_init_leave (&contacts_typeset_type_id__once, contacts_typeset_type_id);
	}
	return contacts_typeset_type_id__once;
}

static void
_vala_contacts_typeset_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	ContactsTypeSet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_TYPESET, ContactsTypeSet);
#line 14 "../src/core/contacts-type-set.vala"
	switch (property_id) {
#line 14 "../src/core/contacts-type-set.vala"
		case CONTACTS_TYPESET_CATEGORY_PROPERTY:
#line 14 "../src/core/contacts-type-set.vala"
		g_value_set_string (value, contacts_typeset_get_category (self));
#line 14 "../src/core/contacts-type-set.vala"
		break;
#line 1374 "contacts-type-set.c"
		default:
#line 14 "../src/core/contacts-type-set.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/core/contacts-type-set.vala"
		break;
#line 1380 "contacts-type-set.c"
	}
}

static void
_vala_contacts_typeset_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	ContactsTypeSet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_TYPESET, ContactsTypeSet);
#line 14 "../src/core/contacts-type-set.vala"
	switch (property_id) {
#line 14 "../src/core/contacts-type-set.vala"
		case CONTACTS_TYPESET_CATEGORY_PROPERTY:
#line 14 "../src/core/contacts-type-set.vala"
		contacts_typeset_set_category (self, g_value_get_string (value));
#line 14 "../src/core/contacts-type-set.vala"
		break;
#line 1400 "contacts-type-set.c"
		default:
#line 14 "../src/core/contacts-type-set.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/core/contacts-type-set.vala"
		break;
#line 1406 "contacts-type-set.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 18 "../src/core/contacts-contact.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1417 "contacts-type-set.c"
		gssize i;
#line 18 "../src/core/contacts-contact.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 18 "../src/core/contacts-contact.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 18 "../src/core/contacts-contact.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1425 "contacts-type-set.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 18 "../src/core/contacts-contact.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 18 "../src/core/contacts-contact.vala"
	g_free (array);
#line 1440 "contacts-type-set.c"
}

