/* contacts-vcard-type-mapping.c generated by valac 0.56.17, the Vala compiler
 * generated from contacts-vcard-type-mapping.vala, do not modify */

/*
 * Copyright (C) 2018 Niels De Graef <nielsdegraef@gmail.com>
 *
 * SPDX-License-Identifier: GPL-2.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include "contactscore.h"

#define CONTACTS_VCARD_TYPE_MAPPING_MAX_TYPES 3
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define CONTACTS_TYPE_VCARD_TYPE_MAPPING (contacts_vcard_type_mapping_get_type ())
typedef struct _ContactsVcardTypeMapping ContactsVcardTypeMapping;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ContactsVcardTypeMapping {
	const gchar* name;
	const gchar* types[3];
};

VALA_EXTERN GType contacts_vcard_type_mapping_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ContactsVcardTypeMapping* contacts_vcard_type_mapping_dup (const ContactsVcardTypeMapping* self);
VALA_EXTERN void contacts_vcard_type_mapping_free (ContactsVcardTypeMapping* self);
VALA_EXTERN gboolean contacts_vcard_type_mapping_contains (ContactsVcardTypeMapping *self,
                                               const gchar* type);
static gboolean contacts_vcard_type_mapping_types_are_equal (const gchar* a,
                                                      const gchar* b);
VALA_EXTERN gboolean contacts_vcard_type_mapping_matches (ContactsVcardTypeMapping *self,
                                              GeeCollection* types);

/** Returns whether the mapping contains the given vcard type. */
gboolean
contacts_vcard_type_mapping_contains (ContactsVcardTypeMapping *self,
                                      const gchar* type)
{
	gboolean result;
#line 20 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (type != NULL, FALSE);
#line 56 "contacts-vcard-type-mapping.c"
	{
		gint i = 0;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
		i = 0;
#line 61 "contacts-vcard-type-mapping.c"
		{
			gboolean _tmp0_ = FALSE;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
			_tmp0_ = TRUE;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
			while (TRUE) {
#line 68 "contacts-vcard-type-mapping.c"
				gboolean _tmp2_ = FALSE;
				const gchar* _tmp4_;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp0_) {
#line 73 "contacts-vcard-type-mapping.c"
					gint _tmp1_;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp1_ = i;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
					i = _tmp1_ + 1;
#line 79 "contacts-vcard-type-mapping.c"
				}
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
				_tmp0_ = FALSE;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
				if (i < CONTACTS_VCARD_TYPE_MAPPING_MAX_TYPES) {
#line 85 "contacts-vcard-type-mapping.c"
					const gchar* _tmp3_;
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp3_ = (*self).types[i];
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = _tmp3_ != NULL;
#line 91 "contacts-vcard-type-mapping.c"
				} else {
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = FALSE;
#line 95 "contacts-vcard-type-mapping.c"
				}
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp2_) {
#line 21 "../src/core/contacts-vcard-type-mapping.vala"
					break;
#line 101 "contacts-vcard-type-mapping.c"
				}
#line 22 "../src/core/contacts-vcard-type-mapping.vala"
				_tmp4_ = (*self).types[i];
#line 22 "../src/core/contacts-vcard-type-mapping.vala"
				if (contacts_vcard_type_mapping_types_are_equal (_tmp4_, type)) {
#line 23 "../src/core/contacts-vcard-type-mapping.vala"
					result = TRUE;
#line 23 "../src/core/contacts-vcard-type-mapping.vala"
					return result;
#line 111 "contacts-vcard-type-mapping.c"
				}
			}
		}
	}
#line 24 "../src/core/contacts-vcard-type-mapping.vala"
	result = FALSE;
#line 24 "../src/core/contacts-vcard-type-mapping.vala"
	return result;
#line 120 "contacts-vcard-type-mapping.c"
}

/**
   * Checks whether all items in the VcardTypeMapping are in the specified @types.
   * Even though there might be other values in @types, we ignore them.
   *
   * For example: [ HOME, FOO, PREF, BLAH ] should match the [ HOME ] VCard
   * type, but not [ HOME, FAX ]
   */
gboolean
contacts_vcard_type_mapping_matches (ContactsVcardTypeMapping *self,
                                     GeeCollection* types)
{
	gboolean result;
#line 34 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (types != NULL, FALSE);
#line 137 "contacts-vcard-type-mapping.c"
	{
		gint i = 0;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
		i = 0;
#line 142 "contacts-vcard-type-mapping.c"
		{
			gboolean _tmp0_ = FALSE;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
			_tmp0_ = TRUE;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
			while (TRUE) {
#line 149 "contacts-vcard-type-mapping.c"
				gboolean _tmp2_ = FALSE;
				gboolean occurs_in_list = FALSE;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp0_) {
#line 154 "contacts-vcard-type-mapping.c"
					gint _tmp1_;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp1_ = i;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
					i = _tmp1_ + 1;
#line 160 "contacts-vcard-type-mapping.c"
				}
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
				_tmp0_ = FALSE;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
				if (i < CONTACTS_VCARD_TYPE_MAPPING_MAX_TYPES) {
#line 166 "contacts-vcard-type-mapping.c"
					const gchar* _tmp3_;
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp3_ = (*self).types[i];
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = _tmp3_ != NULL;
#line 172 "contacts-vcard-type-mapping.c"
				} else {
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp2_ = FALSE;
#line 176 "contacts-vcard-type-mapping.c"
				}
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
				if (!_tmp2_) {
#line 35 "../src/core/contacts-vcard-type-mapping.vala"
					break;
#line 182 "contacts-vcard-type-mapping.c"
				}
#line 36 "../src/core/contacts-vcard-type-mapping.vala"
				occurs_in_list = FALSE;
#line 186 "contacts-vcard-type-mapping.c"
				{
					GeeIterator* _type_it = NULL;
					GeeIterator* _tmp4_;
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
					_tmp4_ = gee_iterable_iterator ((GeeIterable*) types);
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
					_type_it = _tmp4_;
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
					while (TRUE) {
#line 196 "contacts-vcard-type-mapping.c"
						GeeIterator* _tmp5_;
						gchar* type = NULL;
						GeeIterator* _tmp6_;
						gpointer _tmp7_;
						const gchar* _tmp8_;
						const gchar* _tmp9_;
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp5_ = _type_it;
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
						if (!gee_iterator_next (_tmp5_)) {
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
							break;
#line 209 "contacts-vcard-type-mapping.c"
						}
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp6_ = _type_it;
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp7_ = gee_iterator_get (_tmp6_);
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
						type = (gchar*) _tmp7_;
#line 38 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp8_ = type;
#line 38 "../src/core/contacts-vcard-type-mapping.vala"
						_tmp9_ = (*self).types[i];
#line 38 "../src/core/contacts-vcard-type-mapping.vala"
						if (contacts_vcard_type_mapping_types_are_equal (_tmp8_, _tmp9_)) {
#line 39 "../src/core/contacts-vcard-type-mapping.vala"
							occurs_in_list = TRUE;
#line 40 "../src/core/contacts-vcard-type-mapping.vala"
							_g_free0 (type);
#line 40 "../src/core/contacts-vcard-type-mapping.vala"
							break;
#line 229 "contacts-vcard-type-mapping.c"
						}
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
						_g_free0 (type);
#line 233 "contacts-vcard-type-mapping.c"
					}
#line 37 "../src/core/contacts-vcard-type-mapping.vala"
					_g_object_unref0 (_type_it);
#line 237 "contacts-vcard-type-mapping.c"
				}
#line 44 "../src/core/contacts-vcard-type-mapping.vala"
				if (!occurs_in_list) {
#line 45 "../src/core/contacts-vcard-type-mapping.vala"
					result = FALSE;
#line 45 "../src/core/contacts-vcard-type-mapping.vala"
					return result;
#line 245 "contacts-vcard-type-mapping.c"
				}
			}
		}
	}
#line 47 "../src/core/contacts-vcard-type-mapping.vala"
	result = TRUE;
#line 47 "../src/core/contacts-vcard-type-mapping.vala"
	return result;
#line 254 "contacts-vcard-type-mapping.c"
}

static gboolean
contacts_vcard_type_mapping_types_are_equal (const gchar* a,
                                             const gchar* b)
{
	gboolean result;
#line 50 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 50 "../src/core/contacts-vcard-type-mapping.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 51 "../src/core/contacts-vcard-type-mapping.vala"
	result = g_ascii_strcasecmp (a, b) == 0;
#line 51 "../src/core/contacts-vcard-type-mapping.vala"
	return result;
#line 270 "contacts-vcard-type-mapping.c"
}

ContactsVcardTypeMapping*
contacts_vcard_type_mapping_dup (const ContactsVcardTypeMapping* self)
{
	ContactsVcardTypeMapping* dup;
#line 14 "../src/core/contacts-vcard-type-mapping.vala"
	dup = g_new0 (ContactsVcardTypeMapping, 1);
#line 14 "../src/core/contacts-vcard-type-mapping.vala"
	memcpy (dup, self, sizeof (ContactsVcardTypeMapping));
#line 14 "../src/core/contacts-vcard-type-mapping.vala"
	return dup;
#line 283 "contacts-vcard-type-mapping.c"
}

void
contacts_vcard_type_mapping_free (ContactsVcardTypeMapping* self)
{
#line 14 "../src/core/contacts-vcard-type-mapping.vala"
	g_free (self);
#line 291 "contacts-vcard-type-mapping.c"
}

 G_GNUC_NO_INLINE static GType
contacts_vcard_type_mapping_get_type_once (void)
{
	GType contacts_vcard_type_mapping_type_id;
	contacts_vcard_type_mapping_type_id = g_boxed_type_register_static ("ContactsVcardTypeMapping", (GBoxedCopyFunc) contacts_vcard_type_mapping_dup, (GBoxedFreeFunc) contacts_vcard_type_mapping_free);
	return contacts_vcard_type_mapping_type_id;
}

GType
contacts_vcard_type_mapping_get_type (void)
{
	static volatile gsize contacts_vcard_type_mapping_type_id__once = 0;
	if (g_once_init_enter (&contacts_vcard_type_mapping_type_id__once)) {
		GType contacts_vcard_type_mapping_type_id;
		contacts_vcard_type_mapping_type_id = contacts_vcard_type_mapping_get_type_once ();
		g_once_init_leave (&contacts_vcard_type_mapping_type_id__once, contacts_vcard_type_mapping_type_id);
	}
	return contacts_vcard_type_mapping_type_id__once;
}

