/* contacts-contact-sheet-row.c generated by valac 0.56.17, the Vala compiler
 * generated from contacts-contact-sheet-row.vala, do not modify */

/*
 * Copyright (C) 2024 Niels De Graef <nielsdegraef@gmail.com>
 *
 * SPDX-License-Identifier: GPL-2.0-or-later
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "contactscore.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CONTACTS_TYPE_CONTACT_SHEET_ROW (contacts_contact_sheet_row_get_type ())
#define CONTACTS_CONTACT_SHEET_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_CONTACT_SHEET_ROW, ContactsContactSheetRow))
#define CONTACTS_CONTACT_SHEET_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_CONTACT_SHEET_ROW, ContactsContactSheetRowClass))
#define CONTACTS_IS_CONTACT_SHEET_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_CONTACT_SHEET_ROW))
#define CONTACTS_IS_CONTACT_SHEET_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_CONTACT_SHEET_ROW))
#define CONTACTS_CONTACT_SHEET_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_CONTACT_SHEET_ROW, ContactsContactSheetRowClass))

typedef struct _ContactsContactSheetRow ContactsContactSheetRow;
typedef struct _ContactsContactSheetRowClass ContactsContactSheetRowClass;
typedef struct _ContactsContactSheetRowPrivate ContactsContactSheetRowPrivate;
enum  {
	CONTACTS_CONTACT_SHEET_ROW_0_PROPERTY,
	CONTACTS_CONTACT_SHEET_ROW_NUM_PROPERTIES
};
static GParamSpec* contacts_contact_sheet_row_properties[CONTACTS_CONTACT_SHEET_ROW_NUM_PROPERTIES];

struct _ContactsContactSheetRow {
	GtkListBoxRow parent_instance;
	ContactsContactSheetRowPrivate * priv;
};

struct _ContactsContactSheetRowClass {
	GtkListBoxRowClass parent_class;
};

struct _ContactsContactSheetRowPrivate {
	GtkImage* image;
	GtkLabel* title;
	GtkLabel* subtitle;
	GtkBox* suffixes;
};

static gint ContactsContactSheetRow_private_offset;
static gpointer contacts_contact_sheet_row_parent_class = NULL;

VALA_EXTERN GType contacts_contact_sheet_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsContactSheetRow, g_object_unref)
VALA_EXTERN ContactsContactSheetRow* contacts_contact_sheet_row_new (ContactsChunk* chunk,
                                                         const gchar* title,
                                                         const gchar* subtitle);
VALA_EXTERN ContactsContactSheetRow* contacts_contact_sheet_row_construct (GType object_type,
                                                               ContactsChunk* chunk,
                                                               const gchar* title,
                                                               const gchar* subtitle);
VALA_EXTERN void contacts_contact_sheet_row_set_title_direction (ContactsContactSheetRow* self,
                                                     GtkTextDirection direction);
VALA_EXTERN GtkButton* contacts_contact_sheet_row_add_button (ContactsContactSheetRow* self,
                                                  const gchar* icon);
static void contacts_contact_sheet_row_finalize (GObject * obj);
static GType contacts_contact_sheet_row_get_type_once (void);

static inline gpointer
contacts_contact_sheet_row_get_instance_private (ContactsContactSheetRow* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsContactSheetRow_private_offset);
}

ContactsContactSheetRow*
contacts_contact_sheet_row_construct (GType object_type,
                                      ContactsChunk* chunk,
                                      const gchar* title,
                                      const gchar* subtitle)
{
	ContactsContactSheetRow * self = NULL;
	const gchar* icon_name = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkLabel* _tmp8_;
#line 26 "../src/contacts-contact-sheet-row.vala"
	g_return_val_if_fail (chunk != NULL, NULL);
#line 26 "../src/contacts-contact-sheet-row.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 26 "../src/contacts-contact-sheet-row.vala"
	self = (ContactsContactSheetRow*) g_object_new (object_type, NULL);
#line 27 "../src/contacts-contact-sheet-row.vala"
	_tmp0_ = contacts_chunk_get_icon_name (chunk);
#line 27 "../src/contacts-contact-sheet-row.vala"
	_tmp1_ = _tmp0_;
#line 27 "../src/contacts-contact-sheet-row.vala"
	icon_name = _tmp1_;
#line 28 "../src/contacts-contact-sheet-row.vala"
	_tmp2_ = icon_name;
#line 28 "../src/contacts-contact-sheet-row.vala"
	if (_tmp2_ != NULL) {
#line 121 "contacts-contact-sheet-row.c"
		GtkImage* _tmp3_;
		const gchar* _tmp4_;
		GtkImage* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 29 "../src/contacts-contact-sheet-row.vala"
		_tmp3_ = self->priv->image;
#line 29 "../src/contacts-contact-sheet-row.vala"
		_tmp4_ = icon_name;
#line 29 "../src/contacts-contact-sheet-row.vala"
		g_object_set (_tmp3_, "icon-name", _tmp4_, NULL);
#line 30 "../src/contacts-contact-sheet-row.vala"
		_tmp5_ = self->priv->image;
#line 30 "../src/contacts-contact-sheet-row.vala"
		_tmp6_ = contacts_chunk_get_display_name (chunk);
#line 30 "../src/contacts-contact-sheet-row.vala"
		_tmp7_ = _tmp6_;
#line 30 "../src/contacts-contact-sheet-row.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _tmp7_);
#line 141 "contacts-contact-sheet-row.c"
	}
#line 33 "../src/contacts-contact-sheet-row.vala"
	_tmp8_ = self->priv->title;
#line 33 "../src/contacts-contact-sheet-row.vala"
	gtk_label_set_label (_tmp8_, title);
#line 35 "../src/contacts-contact-sheet-row.vala"
	if (subtitle != NULL) {
#line 149 "contacts-contact-sheet-row.c"
		GtkLabel* _tmp9_;
#line 36 "../src/contacts-contact-sheet-row.vala"
		_tmp9_ = self->priv->subtitle;
#line 36 "../src/contacts-contact-sheet-row.vala"
		gtk_label_set_label (_tmp9_, subtitle);
#line 155 "contacts-contact-sheet-row.c"
	}
#line 26 "../src/contacts-contact-sheet-row.vala"
	return self;
#line 159 "contacts-contact-sheet-row.c"
}

ContactsContactSheetRow*
contacts_contact_sheet_row_new (ContactsChunk* chunk,
                                const gchar* title,
                                const gchar* subtitle)
{
#line 26 "../src/contacts-contact-sheet-row.vala"
	return contacts_contact_sheet_row_construct (CONTACTS_TYPE_CONTACT_SHEET_ROW, chunk, title, subtitle);
#line 169 "contacts-contact-sheet-row.c"
}

void
contacts_contact_sheet_row_set_title_direction (ContactsContactSheetRow* self,
                                                GtkTextDirection direction)
{
	GtkLabel* _tmp0_;
#line 39 "../src/contacts-contact-sheet-row.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/contacts-contact-sheet-row.vala"
	_tmp0_ = self->priv->title;
#line 40 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_set_direction ((GtkWidget*) _tmp0_, direction);
#line 41 "../src/contacts-contact-sheet-row.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 185 "contacts-contact-sheet-row.c"
		GtkLabel* _tmp1_;
#line 42 "../src/contacts-contact-sheet-row.vala"
		_tmp1_ = self->priv->title;
#line 42 "../src/contacts-contact-sheet-row.vala"
		gtk_label_set_xalign (_tmp1_, 1.0f);
#line 191 "contacts-contact-sheet-row.c"
	}
}

GtkButton*
contacts_contact_sheet_row_add_button (ContactsContactSheetRow* self,
                                       const gchar* icon)
{
	GtkButton* button = NULL;
	GtkButton* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkButton* result;
#line 45 "../src/contacts-contact-sheet-row.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/contacts-contact-sheet-row.vala"
	g_return_val_if_fail (icon != NULL, NULL);
#line 46 "../src/contacts-contact-sheet-row.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name (icon);
#line 46 "../src/contacts-contact-sheet-row.vala"
	g_object_ref_sink (_tmp0_);
#line 46 "../src/contacts-contact-sheet-row.vala"
	button = _tmp0_;
#line 47 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_set_valign ((GtkWidget*) button, GTK_ALIGN_CENTER);
#line 48 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_add_css_class ((GtkWidget*) button, "flat");
#line 49 "../src/contacts-contact-sheet-row.vala"
	_tmp1_ = self->priv->suffixes;
#line 49 "../src/contacts-contact-sheet-row.vala"
	gtk_box_append (_tmp1_, (GtkWidget*) button);
#line 50 "../src/contacts-contact-sheet-row.vala"
	_tmp2_ = self->priv->suffixes;
#line 50 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 51 "../src/contacts-contact-sheet-row.vala"
	result = button;
#line 51 "../src/contacts-contact-sheet-row.vala"
	return result;
#line 230 "contacts-contact-sheet-row.c"
}

static void
contacts_contact_sheet_row_class_init (ContactsContactSheetRowClass * klass,
                                       gpointer klass_data)
{
#line 15 "../src/contacts-contact-sheet-row.vala"
	contacts_contact_sheet_row_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/contacts-contact-sheet-row.vala"
	g_type_class_adjust_private_offset (klass, &ContactsContactSheetRow_private_offset);
#line 15 "../src/contacts-contact-sheet-row.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_contact_sheet_row_finalize;
#line 15 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Contacts/ui/contacts-contact-sheet-row.ui");
#line 15 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image", FALSE, ContactsContactSheetRow_private_offset + G_STRUCT_OFFSET (ContactsContactSheetRowPrivate, image));
#line 15 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title", FALSE, ContactsContactSheetRow_private_offset + G_STRUCT_OFFSET (ContactsContactSheetRowPrivate, title));
#line 15 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subtitle", FALSE, ContactsContactSheetRow_private_offset + G_STRUCT_OFFSET (ContactsContactSheetRowPrivate, subtitle));
#line 15 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "suffixes", FALSE, ContactsContactSheetRow_private_offset + G_STRUCT_OFFSET (ContactsContactSheetRowPrivate, suffixes));
#line 253 "contacts-contact-sheet-row.c"
}

static void
contacts_contact_sheet_row_instance_init (ContactsContactSheetRow * self,
                                          gpointer klass)
{
#line 15 "../src/contacts-contact-sheet-row.vala"
	self->priv = contacts_contact_sheet_row_get_instance_private (self);
#line 15 "../src/contacts-contact-sheet-row.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 264 "contacts-contact-sheet-row.c"
}

static void
contacts_contact_sheet_row_finalize (GObject * obj)
{
	ContactsContactSheetRow * self;
#line 15 "../src/contacts-contact-sheet-row.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_CONTACT_SHEET_ROW, ContactsContactSheetRow);
#line 15 "../src/contacts-contact-sheet-row.vala"
	G_OBJECT_CLASS (contacts_contact_sheet_row_parent_class)->finalize (obj);
#line 275 "contacts-contact-sheet-row.c"
}

/**
 * ContactSheetRow is a custom Gtk.ListBoxRow for displaying a field in the
 * ContactSheet widget, similar to when one would use an Adw.ActionRow (or
 * generally a Adw.PreferencesRow).
 */
 G_GNUC_NO_INLINE static GType
contacts_contact_sheet_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsContactSheetRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_contact_sheet_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsContactSheetRow), 0, (GInstanceInitFunc) contacts_contact_sheet_row_instance_init, NULL };
	GType contacts_contact_sheet_row_type_id;
	contacts_contact_sheet_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "ContactsContactSheetRow", &g_define_type_info, 0);
	ContactsContactSheetRow_private_offset = g_type_add_instance_private (contacts_contact_sheet_row_type_id, sizeof (ContactsContactSheetRowPrivate));
	return contacts_contact_sheet_row_type_id;
}

GType
contacts_contact_sheet_row_get_type (void)
{
	static volatile gsize contacts_contact_sheet_row_type_id__once = 0;
	if (g_once_init_enter (&contacts_contact_sheet_row_type_id__once)) {
		GType contacts_contact_sheet_row_type_id;
		contacts_contact_sheet_row_type_id = contacts_contact_sheet_row_get_type_once ();
		g_once_init_leave (&contacts_contact_sheet_row_type_id__once, contacts_contact_sheet_row_type_id);
	}
	return contacts_contact_sheet_row_type_id__once;
}

