/* contacts-chunk-property-filter.c generated by valac 0.56.17, the Vala compiler
 * generated from contacts-chunk-property-filter.vala, do not modify */

/*
 * Copyright (C) 2022 Niels De Graef <nielsdegraef@gmail.com>
 *
 * SPDX-License-Identifier: GPL-2.0-or-later
 */

#include "contacts.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "contactscore.h"
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CONTACTS_CHUNK_PROPERTY_FILTER_0_PROPERTY,
	CONTACTS_CHUNK_PROPERTY_FILTER_ALLOWED_PROPERTIES_PROPERTY,
	CONTACTS_CHUNK_PROPERTY_FILTER_NUM_PROPERTIES
};
static GParamSpec* contacts_chunk_property_filter_properties[CONTACTS_CHUNK_PROPERTY_FILTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ContactsChunkPropertyFilterPrivate {
	GtkStringList* _allowed_properties;
};

static gint ContactsChunkPropertyFilter_private_offset;
static gpointer contacts_chunk_property_filter_parent_class = NULL;

static gboolean contacts_chunk_property_filter_real_match (GtkFilter* base,
                                                    GObject* item);
static gboolean contacts_chunk_property_filter_match_property_name (ContactsChunkPropertyFilter* self,
                                                             ContactsChunk* chunk);
static GtkFilterMatch contacts_chunk_property_filter_real_get_strictness (GtkFilter* base);
static void _contacts_chunk_property_filter_allowed_properties___lambda4_ (ContactsChunkPropertyFilter* self,
                                                                    GListModel* list,
                                                                    guint pos,
                                                                    guint removed,
                                                                    guint added);
static void __contacts_chunk_property_filter_allowed_properties___lambda4__g_list_model_items_changed (GListModel* _sender,
                                                                                                guint position,
                                                                                                guint removed,
                                                                                                guint added,
                                                                                                gpointer self);
static void contacts_chunk_property_filter_finalize (GObject * obj);
static GType contacts_chunk_property_filter_get_type_once (void);
static void _vala_contacts_chunk_property_filter_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_contacts_chunk_property_filter_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
contacts_chunk_property_filter_get_instance_private (ContactsChunkPropertyFilter* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsChunkPropertyFilter_private_offset);
}

/**
   * Creates a ChunkPropertyFilter for a specific property
   */
ContactsChunkPropertyFilter*
contacts_chunk_property_filter_construct (GType object_type,
                                          gchar** properties,
                                          gint properties_length1)
{
	ContactsChunkPropertyFilter * self = NULL;
	GtkStringList* _tmp0_;
	GtkStringList* _tmp1_;
#line 35 "../src/contacts-chunk-property-filter.vala"
	_tmp0_ = gtk_string_list_new (properties);
#line 35 "../src/contacts-chunk-property-filter.vala"
	_tmp1_ = _tmp0_;
#line 35 "../src/contacts-chunk-property-filter.vala"
	self = (ContactsChunkPropertyFilter*) g_object_new (object_type, "allowed-properties", _tmp1_, NULL);
#line 35 "../src/contacts-chunk-property-filter.vala"
	_g_object_unref0 (_tmp1_);
#line 34 "../src/contacts-chunk-property-filter.vala"
	return self;
#line 103 "contacts-chunk-property-filter.c"
}

ContactsChunkPropertyFilter*
contacts_chunk_property_filter_new (gchar** properties,
                                    gint properties_length1)
{
#line 34 "../src/contacts-chunk-property-filter.vala"
	return contacts_chunk_property_filter_construct (CONTACTS_TYPE_CHUNK_PROPERTY_FILTER, properties, properties_length1);
#line 112 "contacts-chunk-property-filter.c"
}

/**
   * Creates a ChunkPropertyFilter for a specific property
   */
ContactsChunkPropertyFilter*
contacts_chunk_property_filter_construct_for_single (GType object_type,
                                                     const gchar* property_name)
{
	ContactsChunkPropertyFilter * self = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	GtkStringList* _tmp3_;
	GtkStringList* _tmp4_;
#line 41 "../src/contacts-chunk-property-filter.vala"
	g_return_val_if_fail (property_name != NULL, NULL);
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp0_ = g_strdup (property_name);
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp1_[0] = _tmp0_;
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp2__length1 = 1;
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp3_ = gtk_string_list_new (_tmp2_);
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp4_ = _tmp3_;
#line 42 "../src/contacts-chunk-property-filter.vala"
	self = (ContactsChunkPropertyFilter*) g_object_new (object_type, "allowed-properties", _tmp4_, NULL);
#line 42 "../src/contacts-chunk-property-filter.vala"
	_g_object_unref0 (_tmp4_);
#line 42 "../src/contacts-chunk-property-filter.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 41 "../src/contacts-chunk-property-filter.vala"
	return self;
#line 153 "contacts-chunk-property-filter.c"
}

ContactsChunkPropertyFilter*
contacts_chunk_property_filter_new_for_single (const gchar* property_name)
{
#line 41 "../src/contacts-chunk-property-filter.vala"
	return contacts_chunk_property_filter_construct_for_single (CONTACTS_TYPE_CHUNK_PROPERTY_FILTER, property_name);
#line 161 "contacts-chunk-property-filter.c"
}

static gboolean
contacts_chunk_property_filter_real_match (GtkFilter* base,
                                           GObject* item)
{
	ContactsChunkPropertyFilter * self;
	ContactsChunk* chunk = NULL;
	gboolean result;
#line 45 "../src/contacts-chunk-property-filter.vala"
	self = (ContactsChunkPropertyFilter*) base;
#line 46 "../src/contacts-chunk-property-filter.vala"
	chunk = G_TYPE_CHECK_INSTANCE_CAST (item, CONTACTS_TYPE_CHUNK, ContactsChunk);
#line 47 "../src/contacts-chunk-property-filter.vala"
	result = contacts_chunk_property_filter_match_property_name (self, chunk);
#line 47 "../src/contacts-chunk-property-filter.vala"
	return result;
#line 179 "contacts-chunk-property-filter.c"
}

static gboolean
contacts_chunk_property_filter_match_property_name (ContactsChunkPropertyFilter* self,
                                                    ContactsChunk* chunk)
{
	GtkStringList* _tmp0_;
	GtkStringList* _tmp1_;
	gboolean result;
#line 50 "../src/contacts-chunk-property-filter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/contacts-chunk-property-filter.vala"
	g_return_val_if_fail (chunk != NULL, FALSE);
#line 51 "../src/contacts-chunk-property-filter.vala"
	_tmp0_ = contacts_chunk_property_filter_get_allowed_properties (self);
#line 51 "../src/contacts-chunk-property-filter.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/contacts-chunk-property-filter.vala"
	if (g_list_model_get_n_items ((GListModel*) _tmp1_) == ((guint) 0)) {
#line 52 "../src/contacts-chunk-property-filter.vala"
		result = TRUE;
#line 52 "../src/contacts-chunk-property-filter.vala"
		return result;
#line 203 "contacts-chunk-property-filter.c"
	}
	{
		guint i = 0U;
#line 54 "../src/contacts-chunk-property-filter.vala"
		i = (guint) 0;
#line 209 "contacts-chunk-property-filter.c"
		{
			gboolean _tmp2_ = FALSE;
#line 54 "../src/contacts-chunk-property-filter.vala"
			_tmp2_ = TRUE;
#line 54 "../src/contacts-chunk-property-filter.vala"
			while (TRUE) {
#line 216 "contacts-chunk-property-filter.c"
				GtkStringList* _tmp4_;
				GtkStringList* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				GtkStringList* _tmp8_;
				GtkStringList* _tmp9_;
				const gchar* _tmp10_;
#line 54 "../src/contacts-chunk-property-filter.vala"
				if (!_tmp2_) {
#line 226 "contacts-chunk-property-filter.c"
					guint _tmp3_;
#line 54 "../src/contacts-chunk-property-filter.vala"
					_tmp3_ = i;
#line 54 "../src/contacts-chunk-property-filter.vala"
					i = _tmp3_ + 1;
#line 232 "contacts-chunk-property-filter.c"
				}
#line 54 "../src/contacts-chunk-property-filter.vala"
				_tmp2_ = FALSE;
#line 54 "../src/contacts-chunk-property-filter.vala"
				_tmp4_ = contacts_chunk_property_filter_get_allowed_properties (self);
#line 54 "../src/contacts-chunk-property-filter.vala"
				_tmp5_ = _tmp4_;
#line 54 "../src/contacts-chunk-property-filter.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp5_))) {
#line 54 "../src/contacts-chunk-property-filter.vala"
					break;
#line 244 "contacts-chunk-property-filter.c"
				}
#line 55 "../src/contacts-chunk-property-filter.vala"
				_tmp6_ = contacts_chunk_get_property_name (chunk);
#line 55 "../src/contacts-chunk-property-filter.vala"
				_tmp7_ = _tmp6_;
#line 55 "../src/contacts-chunk-property-filter.vala"
				_tmp8_ = contacts_chunk_property_filter_get_allowed_properties (self);
#line 55 "../src/contacts-chunk-property-filter.vala"
				_tmp9_ = _tmp8_;
#line 55 "../src/contacts-chunk-property-filter.vala"
				_tmp10_ = gtk_string_list_get_string (_tmp9_, i);
#line 55 "../src/contacts-chunk-property-filter.vala"
				if (g_strcmp0 (_tmp7_, _tmp10_) == 0) {
#line 56 "../src/contacts-chunk-property-filter.vala"
					result = TRUE;
#line 56 "../src/contacts-chunk-property-filter.vala"
					return result;
#line 262 "contacts-chunk-property-filter.c"
				}
			}
		}
	}
#line 58 "../src/contacts-chunk-property-filter.vala"
	result = FALSE;
#line 58 "../src/contacts-chunk-property-filter.vala"
	return result;
#line 271 "contacts-chunk-property-filter.c"
}

static GtkFilterMatch
contacts_chunk_property_filter_real_get_strictness (GtkFilter* base)
{
	ContactsChunkPropertyFilter * self;
	GtkStringList* _tmp0_;
	GtkStringList* _tmp1_;
	GtkFilterMatch result;
#line 61 "../src/contacts-chunk-property-filter.vala"
	self = (ContactsChunkPropertyFilter*) base;
#line 62 "../src/contacts-chunk-property-filter.vala"
	_tmp0_ = contacts_chunk_property_filter_get_allowed_properties (self);
#line 62 "../src/contacts-chunk-property-filter.vala"
	_tmp1_ = _tmp0_;
#line 62 "../src/contacts-chunk-property-filter.vala"
	if (g_list_model_get_n_items ((GListModel*) _tmp1_) == ((guint) 0)) {
#line 63 "../src/contacts-chunk-property-filter.vala"
		result = GTK_FILTER_MATCH_ALL;
#line 63 "../src/contacts-chunk-property-filter.vala"
		return result;
#line 293 "contacts-chunk-property-filter.c"
	}
#line 64 "../src/contacts-chunk-property-filter.vala"
	result = GTK_FILTER_MATCH_SOME;
#line 64 "../src/contacts-chunk-property-filter.vala"
	return result;
#line 299 "contacts-chunk-property-filter.c"
}

GtkStringList*
contacts_chunk_property_filter_get_allowed_properties (ContactsChunkPropertyFilter* self)
{
	GtkStringList* result;
	GtkStringList* _tmp0_;
#line 16 "../src/contacts-chunk-property-filter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 16 "../src/contacts-chunk-property-filter.vala"
	_tmp0_ = self->priv->_allowed_properties;
#line 16 "../src/contacts-chunk-property-filter.vala"
	result = _tmp0_;
#line 16 "../src/contacts-chunk-property-filter.vala"
	return result;
#line 315 "contacts-chunk-property-filter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/contacts-chunk-property-filter.vala"
	return self ? g_object_ref (self) : NULL;
#line 323 "contacts-chunk-property-filter.c"
}

static void
_contacts_chunk_property_filter_allowed_properties___lambda4_ (ContactsChunkPropertyFilter* self,
                                                               GListModel* list,
                                                               guint pos,
                                                               guint removed,
                                                               guint added)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 19 "../src/contacts-chunk-property-filter.vala"
	g_return_if_fail (list != NULL);
#line 20 "../src/contacts-chunk-property-filter.vala"
	if (added > ((guint) 0)) {
#line 20 "../src/contacts-chunk-property-filter.vala"
		_tmp1_ = removed == ((guint) 0);
#line 341 "contacts-chunk-property-filter.c"
	} else {
#line 20 "../src/contacts-chunk-property-filter.vala"
		_tmp1_ = FALSE;
#line 345 "contacts-chunk-property-filter.c"
	}
#line 20 "../src/contacts-chunk-property-filter.vala"
	if (_tmp1_) {
#line 20 "../src/contacts-chunk-property-filter.vala"
		_tmp0_ = TRUE;
#line 351 "contacts-chunk-property-filter.c"
	} else {
#line 20 "../src/contacts-chunk-property-filter.vala"
		_tmp0_ = g_list_model_get_n_items (list) == ((guint) 0);
#line 355 "contacts-chunk-property-filter.c"
	}
#line 20 "../src/contacts-chunk-property-filter.vala"
	if (_tmp0_) {
#line 21 "../src/contacts-chunk-property-filter.vala"
		gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_LESS_STRICT);
#line 361 "contacts-chunk-property-filter.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 22 "../src/contacts-chunk-property-filter.vala"
		if (added == ((guint) 0)) {
#line 22 "../src/contacts-chunk-property-filter.vala"
			_tmp2_ = removed > ((guint) 0);
#line 368 "contacts-chunk-property-filter.c"
		} else {
#line 22 "../src/contacts-chunk-property-filter.vala"
			_tmp2_ = FALSE;
#line 372 "contacts-chunk-property-filter.c"
		}
#line 22 "../src/contacts-chunk-property-filter.vala"
		if (_tmp2_) {
#line 23 "../src/contacts-chunk-property-filter.vala"
			gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_MORE_STRICT);
#line 378 "contacts-chunk-property-filter.c"
		} else {
#line 25 "../src/contacts-chunk-property-filter.vala"
			gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_DIFFERENT);
#line 382 "contacts-chunk-property-filter.c"
		}
	}
}

static void
__contacts_chunk_property_filter_allowed_properties___lambda4__g_list_model_items_changed (GListModel* _sender,
                                                                                           guint position,
                                                                                           guint removed,
                                                                                           guint added,
                                                                                           gpointer self)
{
#line 19 "../src/contacts-chunk-property-filter.vala"
	_contacts_chunk_property_filter_allowed_properties___lambda4_ ((ContactsChunkPropertyFilter*) self, _sender, position, removed, added);
#line 396 "contacts-chunk-property-filter.c"
}

void
contacts_chunk_property_filter_set_allowed_properties (ContactsChunkPropertyFilter* self,
                                                       GtkStringList* value)
{
	GtkStringList* _tmp0_;
#line 17 "../src/contacts-chunk-property-filter.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/contacts-chunk-property-filter.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/contacts-chunk-property-filter.vala"
	_g_object_unref0 (self->priv->_allowed_properties);
#line 18 "../src/contacts-chunk-property-filter.vala"
	self->priv->_allowed_properties = _tmp0_;
#line 19 "../src/contacts-chunk-property-filter.vala"
	g_signal_connect_object ((GListModel*) value, "items-changed", (GCallback) __contacts_chunk_property_filter_allowed_properties___lambda4__g_list_model_items_changed, self, 0);
#line 17 "../src/contacts-chunk-property-filter.vala"
	g_object_notify_by_pspec ((GObject *) self, contacts_chunk_property_filter_properties[CONTACTS_CHUNK_PROPERTY_FILTER_ALLOWED_PROPERTIES_PROPERTY]);
#line 416 "contacts-chunk-property-filter.c"
}

static void
contacts_chunk_property_filter_class_init (ContactsChunkPropertyFilterClass * klass,
                                           gpointer klass_data)
{
#line 12 "../src/contacts-chunk-property-filter.vala"
	contacts_chunk_property_filter_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/contacts-chunk-property-filter.vala"
	g_type_class_adjust_private_offset (klass, &ContactsChunkPropertyFilter_private_offset);
#line 12 "../src/contacts-chunk-property-filter.vala"
	((GtkFilterClass *) klass)->match = (gboolean (*) (GtkFilter*, GObject*)) contacts_chunk_property_filter_real_match;
#line 12 "../src/contacts-chunk-property-filter.vala"
	((GtkFilterClass *) klass)->get_strictness = (GtkFilterMatch (*) (GtkFilter*)) contacts_chunk_property_filter_real_get_strictness;
#line 12 "../src/contacts-chunk-property-filter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_chunk_property_filter_get_property;
#line 12 "../src/contacts-chunk-property-filter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_chunk_property_filter_set_property;
#line 12 "../src/contacts-chunk-property-filter.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_chunk_property_filter_finalize;
#line 437 "contacts-chunk-property-filter.c"
	/** If not empty, only the properties in the string list will match */
#line 12 "../src/contacts-chunk-property-filter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_CHUNK_PROPERTY_FILTER_ALLOWED_PROPERTIES_PROPERTY, contacts_chunk_property_filter_properties[CONTACTS_CHUNK_PROPERTY_FILTER_ALLOWED_PROPERTIES_PROPERTY] = g_param_spec_object ("allowed-properties", "allowed-properties", "allowed-properties", gtk_string_list_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 441 "contacts-chunk-property-filter.c"
}

static void
contacts_chunk_property_filter_instance_init (ContactsChunkPropertyFilter * self,
                                              gpointer klass)
{
#line 12 "../src/contacts-chunk-property-filter.vala"
	self->priv = contacts_chunk_property_filter_get_instance_private (self);
#line 29 "../src/contacts-chunk-property-filter.vala"
	self->priv->_allowed_properties = NULL;
#line 452 "contacts-chunk-property-filter.c"
}

static void
contacts_chunk_property_filter_finalize (GObject * obj)
{
	ContactsChunkPropertyFilter * self;
#line 12 "../src/contacts-chunk-property-filter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_CHUNK_PROPERTY_FILTER, ContactsChunkPropertyFilter);
#line 29 "../src/contacts-chunk-property-filter.vala"
	_g_object_unref0 (self->priv->_allowed_properties);
#line 12 "../src/contacts-chunk-property-filter.vala"
	G_OBJECT_CLASS (contacts_chunk_property_filter_parent_class)->finalize (obj);
#line 465 "contacts-chunk-property-filter.c"
}

/**
 * A custom GtkFilter to filter {@link Chunk}s on a given property.
 */
 G_GNUC_NO_INLINE static GType
contacts_chunk_property_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsChunkPropertyFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_chunk_property_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsChunkPropertyFilter), 0, (GInstanceInitFunc) contacts_chunk_property_filter_instance_init, NULL };
	GType contacts_chunk_property_filter_type_id;
	contacts_chunk_property_filter_type_id = g_type_register_static (gtk_filter_get_type (), "ContactsChunkPropertyFilter", &g_define_type_info, 0);
	ContactsChunkPropertyFilter_private_offset = g_type_add_instance_private (contacts_chunk_property_filter_type_id, sizeof (ContactsChunkPropertyFilterPrivate));
	return contacts_chunk_property_filter_type_id;
}

GType
contacts_chunk_property_filter_get_type (void)
{
	static volatile gsize contacts_chunk_property_filter_type_id__once = 0;
	if (g_once_init_enter (&contacts_chunk_property_filter_type_id__once)) {
		GType contacts_chunk_property_filter_type_id;
		contacts_chunk_property_filter_type_id = contacts_chunk_property_filter_get_type_once ();
		g_once_init_leave (&contacts_chunk_property_filter_type_id__once, contacts_chunk_property_filter_type_id);
	}
	return contacts_chunk_property_filter_type_id__once;
}

static void
_vala_contacts_chunk_property_filter_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	ContactsChunkPropertyFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_CHUNK_PROPERTY_FILTER, ContactsChunkPropertyFilter);
#line 12 "../src/contacts-chunk-property-filter.vala"
	switch (property_id) {
#line 12 "../src/contacts-chunk-property-filter.vala"
		case CONTACTS_CHUNK_PROPERTY_FILTER_ALLOWED_PROPERTIES_PROPERTY:
#line 12 "../src/contacts-chunk-property-filter.vala"
		g_value_set_object (value, contacts_chunk_property_filter_get_allowed_properties (self));
#line 12 "../src/contacts-chunk-property-filter.vala"
		break;
#line 509 "contacts-chunk-property-filter.c"
		default:
#line 12 "../src/contacts-chunk-property-filter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/contacts-chunk-property-filter.vala"
		break;
#line 515 "contacts-chunk-property-filter.c"
	}
}

static void
_vala_contacts_chunk_property_filter_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	ContactsChunkPropertyFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_CHUNK_PROPERTY_FILTER, ContactsChunkPropertyFilter);
#line 12 "../src/contacts-chunk-property-filter.vala"
	switch (property_id) {
#line 12 "../src/contacts-chunk-property-filter.vala"
		case CONTACTS_CHUNK_PROPERTY_FILTER_ALLOWED_PROPERTIES_PROPERTY:
#line 12 "../src/contacts-chunk-property-filter.vala"
		contacts_chunk_property_filter_set_allowed_properties (self, g_value_get_object (value));
#line 12 "../src/contacts-chunk-property-filter.vala"
		break;
#line 535 "contacts-chunk-property-filter.c"
		default:
#line 12 "../src/contacts-chunk-property-filter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "../src/contacts-chunk-property-filter.vala"
		break;
#line 541 "contacts-chunk-property-filter.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

