/* contacts-manual-filter.c generated by valac 0.56.17, the Vala compiler
 * generated from contacts-manual-filter.vala, do not modify */

/*
 * Copyright (C) 2023 Niels De Graef <nielsdegraef@gmail.com>
 *
 * SPDX-License-Identifier: GPL-2.0-or-later
 */

#include "contacts.h"
#include <glib.h>
#include <folks/folks.h>
#include <gtk/gtk.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CONTACTS_MANUAL_FILTER_0_PROPERTY,
	CONTACTS_MANUAL_FILTER_NUM_PROPERTIES
};
static GParamSpec* contacts_manual_filter_properties[CONTACTS_MANUAL_FILTER_NUM_PROPERTIES];
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ContactsManualFilterPrivate {
	GPtrArray* hidden;
};

static gint ContactsManualFilter_private_offset;
static gpointer contacts_manual_filter_parent_class = NULL;

static gboolean contacts_manual_filter_real_match (GtkFilter* base,
                                            GObject* item);
static GtkFilterMatch contacts_manual_filter_real_get_strictness (GtkFilter* base);
static void contacts_manual_filter_finalize (GObject * obj);
static GType contacts_manual_filter_get_type_once (void);

static inline gpointer
contacts_manual_filter_get_instance_private (ContactsManualFilter* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsManualFilter_private_offset);
}

/**
   * Marks that the given individual should to be hidden
   */
void
contacts_manual_filter_add_individual (ContactsManualFilter* self,
                                       FolksIndividual* individual)
{
	GPtrArray* _tmp0_;
#line 23 "../src/contacts-manual-filter.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/contacts-manual-filter.vala"
	g_return_if_fail (individual != NULL);
#line 24 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 24 "../src/contacts-manual-filter.vala"
	g_ptr_array_add (_tmp0_, individual);
#line 25 "../src/contacts-manual-filter.vala"
	gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_MORE_STRICT);
#line 74 "contacts-manual-filter.c"
}

/**
   * Marks that the given individual should no longer to be hidden
   */
void
contacts_manual_filter_remove_individual (ContactsManualFilter* self,
                                          FolksIndividual* individual)
{
	GPtrArray* _tmp0_;
	GPtrArray* _tmp1_;
#line 31 "../src/contacts-manual-filter.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/contacts-manual-filter.vala"
	g_return_if_fail (individual != NULL);
#line 31 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 31 "../src/contacts-manual-filter.vala"
	_vala_return_if_fail (g_ptr_array_find (_tmp0_, individual, NULL), "this.hidden.find (individual)");
#line 33 "../src/contacts-manual-filter.vala"
	_tmp1_ = self->priv->hidden;
#line 33 "../src/contacts-manual-filter.vala"
	g_ptr_array_remove (_tmp1_, individual);
#line 34 "../src/contacts-manual-filter.vala"
	gtk_filter_changed ((GtkFilter*) self, GTK_FILTER_CHANGE_LESS_STRICT);
#line 100 "contacts-manual-filter.c"
}

static gboolean
contacts_manual_filter_real_match (GtkFilter* base,
                                   GObject* item)
{
	ContactsManualFilter * self;
	GPtrArray* _tmp0_;
	gboolean result;
#line 37 "../src/contacts-manual-filter.vala"
	self = (ContactsManualFilter*) base;
#line 37 "../src/contacts-manual-filter.vala"
	_vala_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (item, FOLKS_TYPE_INDIVIDUAL), "item is Individual", FALSE);
#line 39 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 39 "../src/contacts-manual-filter.vala"
	result = !g_ptr_array_find (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (item, FOLKS_TYPE_INDIVIDUAL, FolksIndividual), NULL);
#line 39 "../src/contacts-manual-filter.vala"
	return result;
#line 120 "contacts-manual-filter.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5950 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5951 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5951 "glib-2.0.vapi"
	return result;
#line 133 "contacts-manual-filter.c"
}

static GtkFilterMatch
contacts_manual_filter_real_get_strictness (GtkFilter* base)
{
	ContactsManualFilter * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkFilterMatch result;
#line 42 "../src/contacts-manual-filter.vala"
	self = (ContactsManualFilter*) base;
#line 43 "../src/contacts-manual-filter.vala"
	_tmp0_ = self->priv->hidden;
#line 43 "../src/contacts-manual-filter.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 43 "../src/contacts-manual-filter.vala"
	_tmp2_ = _tmp1_;
#line 43 "../src/contacts-manual-filter.vala"
	if (_tmp2_ == 0) {
#line 44 "../src/contacts-manual-filter.vala"
		result = GTK_FILTER_MATCH_ALL;
#line 44 "../src/contacts-manual-filter.vala"
		return result;
#line 158 "contacts-manual-filter.c"
	}
#line 46 "../src/contacts-manual-filter.vala"
	result = GTK_FILTER_MATCH_SOME;
#line 46 "../src/contacts-manual-filter.vala"
	return result;
#line 164 "contacts-manual-filter.c"
}

ContactsManualFilter*
contacts_manual_filter_construct (GType object_type)
{
	ContactsManualFilter * self = NULL;
#line 14 "../src/contacts-manual-filter.vala"
	self = (ContactsManualFilter*) g_object_new (object_type, NULL);
#line 14 "../src/contacts-manual-filter.vala"
	return self;
#line 175 "contacts-manual-filter.c"
}

ContactsManualFilter*
contacts_manual_filter_new (void)
{
#line 14 "../src/contacts-manual-filter.vala"
	return contacts_manual_filter_construct (CONTACTS_TYPE_MANUAL_FILTER);
#line 183 "contacts-manual-filter.c"
}

static void
contacts_manual_filter_class_init (ContactsManualFilterClass * klass,
                                   gpointer klass_data)
{
#line 14 "../src/contacts-manual-filter.vala"
	contacts_manual_filter_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/contacts-manual-filter.vala"
	g_type_class_adjust_private_offset (klass, &ContactsManualFilter_private_offset);
#line 14 "../src/contacts-manual-filter.vala"
	((GtkFilterClass *) klass)->match = (gboolean (*) (GtkFilter*, GObject*)) contacts_manual_filter_real_match;
#line 14 "../src/contacts-manual-filter.vala"
	((GtkFilterClass *) klass)->get_strictness = (GtkFilterMatch (*) (GtkFilter*)) contacts_manual_filter_real_get_strictness;
#line 14 "../src/contacts-manual-filter.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_manual_filter_finalize;
#line 200 "contacts-manual-filter.c"
}

static void
contacts_manual_filter_instance_init (ContactsManualFilter * self,
                                      gpointer klass)
{
	GPtrArray* _tmp0_;
#line 14 "../src/contacts-manual-filter.vala"
	self->priv = contacts_manual_filter_get_instance_private (self);
#line 18 "../src/contacts-manual-filter.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 18 "../src/contacts-manual-filter.vala"
	self->priv->hidden = _tmp0_;
#line 214 "contacts-manual-filter.c"
}

static void
contacts_manual_filter_finalize (GObject * obj)
{
	ContactsManualFilter * self;
#line 14 "../src/contacts-manual-filter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_MANUAL_FILTER, ContactsManualFilter);
#line 18 "../src/contacts-manual-filter.vala"
	_g_ptr_array_unref0 (self->priv->hidden);
#line 14 "../src/contacts-manual-filter.vala"
	G_OBJECT_CLASS (contacts_manual_filter_parent_class)->finalize (obj);
#line 227 "contacts-manual-filter.c"
}

/**
 * A subclass of {@link Gtk.Filter} which hides a programmatically chosen set
 * of individuals. The main use case here is to temporarily hide individuals
 * that are going to be deleted soon.
 */
 G_GNUC_NO_INLINE static GType
contacts_manual_filter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsManualFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_manual_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsManualFilter), 0, (GInstanceInitFunc) contacts_manual_filter_instance_init, NULL };
	GType contacts_manual_filter_type_id;
	contacts_manual_filter_type_id = g_type_register_static (gtk_filter_get_type (), "ContactsManualFilter", &g_define_type_info, 0);
	ContactsManualFilter_private_offset = g_type_add_instance_private (contacts_manual_filter_type_id, sizeof (ContactsManualFilterPrivate));
	return contacts_manual_filter_type_id;
}

GType
contacts_manual_filter_get_type (void)
{
	static volatile gsize contacts_manual_filter_type_id__once = 0;
	if (g_once_init_enter (&contacts_manual_filter_type_id__once)) {
		GType contacts_manual_filter_type_id;
		contacts_manual_filter_type_id = contacts_manual_filter_get_type_once ();
		g_once_init_leave (&contacts_manual_filter_type_id__once, contacts_manual_filter_type_id);
	}
	return contacts_manual_filter_type_id__once;
}

